#include<stdio.h>
#include<stddef.h>
#include<stdlib.h>
#include<math.h>
#include<mpi.h>
size_t  mx;
int now;
#define den(i,j,k) den[(long)(i)+(long)mx*((long)(j)+(long)ny*(long)(k))]
#define sign(i,j) (j)>0 ? i : -(i)
#define SQR(A) ((A)*(A))

void correl(float *den,int nx,int ny,int nz,int local_nz, int local_z_start,
		float *pk,float *npk,float *cor,float *tpk,float *tnpk,float *tcor,
		float corn1,float std, int myid, int nid,
		float rngm6,float a, int nowflag,float xyz, float rth,int nstep,
		int local_ny_after_transpose, int local_y_start_after_transpose){
	size_t i,j,k;
	float xyy,pi,rng;
	float rnx,rny,rnz;
	size_t nxh,nyh,nzh;
	float wj,wk,wave,delksq,wt1;
	int kbin1,kbin2;
	pi = 3.141592654;
	mx = 2*(nx/2+1);

	rnx = nx;
	rny = ny;
	rnz = nz;
	xyz = rnx/rnz;
	xyy = rny/rnz;
	nxh = nx/2;
	nyh = ny/2;
	nzh = nz/2;
	for(i=0;i<=nx;i++){
		pk[i] = npk[i]=tpk[i]=tnpk[i]=cor[i]=0.;
	}
	for(j=0;j<local_ny_after_transpose;j++){
		wj = xyy*(j+local_y_start_after_transpose);
		if(wj>nyh) wj= wj-nx;
		for(k=0;k<nz;k++){
			wk = xyz*k;
			for(i=0;i<=nxh;i++){
				wave = sqrt(i*i+wj*wj+wk*wk);
/* density array in k-space is transposed order: (i,j,k)-->(i,k,j) */
				delksq = (SQR(den(2*i+1,k,j))+SQR(den(2*i+2,k,j)))*rngm6;
				kbin1 = rint(wave);
				wt1 = wave-kbin1+1;
				kbin2 = kbin1+sign(1.,wt1);
				wt1 = fabs(wt1);
				pk[kbin1] += (1.-wt1)*delksq;
				pk[kbin2] += wt1*delksq;
				npk[kbin1] += 1.-wt1;
				npk[kbin2] += wt1;
			}
		}
	}
	/* Gathering pk in all processors and summing */
	MPI_Reduce(pk,tpk,nx+1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
	MPI_Reduce(npk,tnpk,nx+1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
	if(myid==0){
		for(i=0;i<=nx;i++){
			pk[i] = tpk[i];
			npk[i] = tnpk[i];
		}
	}
	MPI_Bcast(pk,nx+1,MPI_FLOAT,0,MPI_COMM_WORLD);
	MPI_Bcast(npk,nx+1,MPI_FLOAT,0,MPI_COMM_WORLD);
	/* only calculation on root(0) processor */
	if(myid == 0){
		float fact,thk,seper,corn2;
		std = 0.;
		fact = 2.*pi*rth/rnx;
		for(i=1;i<=nx;i++){
			if(npk[i]>0){
				pk[i] = pk[i]/npk[i];
			}
			else 
				pk[i] = 0;
			thk = fact*i;
			std += pk[i]*i*i*pow(sin(thk)-thk*cos(thk),2.)/pow(thk,6.);
		}
		std = sqrt(4.*pi*std*9.);
		for(i=1;i<nx+1;i++){
			seper = 2.*pi*i/rnx;
			for(k=1; k<nx+1;k++){
				cor[i] += sin(k*seper)*(k*pk[k]);
			}
			cor[i] = 2.*rnx*cor[i]/(float)i;
		}
		if(cor[3] > 0. && cor[2] > 0.) {
			corn2 = (log(cor[3])-log(cor[2]))/(log(4.)-log(3.));
		}
		if(nowflag == 1) {
			if(a !=1 && (corn1+1.8)*(corn2+1.8)<=0.) 
				now = 1;
			else 
				now = 0;
		}
		corn1 = corn2;
	}
	{
		FILE *twp;
		twp = fopen("pmevol.map","a");
		fprintf(twp,"%g %g %g\n",a,std,corn1);
		fclose(twp);
	}
	{
		MPI_Bcast(&now,1,MPI_INT,0,MPI_COMM_WORLD);
			if(now == 1) {
				if(myid==0) printf(" Finishing at a= %g\n",a);
				MPI_Finalize();
				exit(0);
			}
	}
}
