#include<stdio.h>
#include<math.h>
#include<stddef.h>
#include<stdlib.h>
#include<srfftw_mpi.h>

#include<mpi.h>
#include "pmheader.h"
#include "macros.h"
#define PI 3.1415926535
#define sign(a,b) b>0? a : (-a)
size_t mx;
float cputime0[100], cputime1[100];
#define den(i,j,k) den[(size_t)i+(size_t)mx*((size_t)(j)+(size_t)ny*(size_t)(k))]
#define denpad(i,j,k) denpad[(size_t)i+(size_t)mx*((size_t)(j)+(size_t)ny*(size_t)(k))]
#define fx(i,j,k) fx[(size_t)i+(size_t)mx*((size_t)(j)+(size_t)ny*(size_t)(k))]
#define fy(i,j,k) fy[(size_t)i+(size_t)mx*((size_t)(j)+(size_t)ny*(size_t)(k))]
#define fz(i,j,k) fz[(size_t)i+(size_t)mx*((size_t)(j)+(size_t)ny*(size_t)(k))]
#define MAX(a,b) a > b ? (a) : (b)
#define MIN(a,b) a < b ? (a) : (b)
#define xabp0(i) xabp0[i+10]
#define xabp1(i) xabp1[i+10]
#define yabp0(i) yabp0[i+10]
#define yabp1(i) yabp1[i+10]
#define zabp0(i) zabp0[i+10]
#define zabp1(i) zabp1[i+10]
float gasdev(long *);
float ran3(long *);
float bpowint(float );
float bpower(float );
float growth(float,float,float);
basicparticletype *bp;

void pmseedforce(int np,basicparticletype *particles,int nn, int nxpos,
		float *den, float *denpad,
		int nx, int ny,int nz,int local_nz, int local_z_start,
		int myid, int nid,rfftwnd_mpi_plan iplan,float omep, float omeplam,
		float omepb){
	float enoughspace,*den2, ken;
	float rnx,rny,rnz;
	float *fx,*fy,*fz,*denped;
	float start_z;
	int mlocalstartz,mlocalnz;
	MPI_Status status;
	float displ,mdispl;
	int stag,rtag,dest,src;
	double tmpken,tken;
	long lnp,tlnp;
	float ktot;
	char dark[4];
	long iseed, iiseed;
	int nspace;
	float size,smooth,h,rth,bias,zi;
	int knyq,ngz,nnp,nznp;
	float npow;
	float xyz,omei,powh,pi,omehs,rknyq,rknyq2,rkinv,xyy;
	float twopi,rngz,rngzc,xxx,rngx,rngy,rngc;
	float pmas,pmass,ai,anow,wavemax,pamp,pamp2,vamp;
	float xnow, xini,bnow,bini;
	float vfact,vfact2,pfact,amax,astep;
	float efold,sfac;
	double delx,tdelx;
	float poten;
	size_t iindex;
	size_t ngh,nhx,nhy,nhz,i,j,k,ky,kz;
	float rk,velpot,xksq,power;
	int sendsize,recvsize,ierror;
	int *displs, *rcounts;
	int ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2;
	int iip1,jjp1,kkp1,iip2,jjp2,kkp2;
    float xp,yp,zp,xmin,ymin,zmin,xd1,yd1,zd1;
    float wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3;
    float wt1,wt2,wt3,wt4,wt5,wt6,wt7,wt8,wt9,wt10;
    float wt11,wt12,wt13,wt14,wt15,wt16,wt17,wt18,wt19,wt20;
    float wt21,wt22,wt23,wt24,wt25,wt26,wt27;
    int i1,i2,i3,j1,j2,j3,k1,k2,k3;
    int xsign,ysign,zsign;
    int nearx,neary,nearz;
    int nz_per;
	float rincube;
	float rdz,rdzstd,rdzmean,rdzmin,rdzmax;
	long npixel;
	fftw_complex work;
	float constant;


	mx = 2*(nx/2+1);
	if(myid==0) TIMER_START(22);
	getpowerparams_(&nspace,&size,&amax,&astep,&npow,&smooth,&h,
			&rth,&bias,&iseed,&omepb);
	sprintf(dark,"cdm");
	npixel = (long)nx*(long)ny*(long)nz;
	rincube = 1./(float) npixel;
	iiseed = iseed*(myid+1);
	xxx = ran3(&iiseed);
	nhx = nx/2;
	nhy = ny/2;
	nhz = nz/2;
	rnx = (float) nx;
	rny = (float) ny;
	rnz = (float) nz;
	rngc = (float) npixel;
    xyz  = rnx/rnz;
    xyy  = rnx/rny;
	twopi = 2.* PI;
	nnp = nx/nspace;
	nznp = nz/nspace;
#ifndef INITIALREADING
	np = nx/nspace*ny/nspace*local_nz/nspace;
#endif
    knyq = nx/2;
    rknyq2 = (float)(knyq*knyq);
    rknyq = twopi*(float)(knyq);
    rkinv = 1./rknyq;
    powh = 0.5*(float)(npow);
    ai = 1.;
    zi = amax-1;
    anow = ai*(1.+zi);
/*
    omei = omep*(1.+zi)/(1.+omep*zi)
*/
    omei = omep*pow(1+zi,3)/
		(omep*pow(1+zi,3)+omeplam+(1-omep-omeplam)*pow(1+zi,2));
    omehs = 1./(omep*h*size);
    smooth = (smooth/sqrt(2.))/rnx/sqrt(2.);
    rth = rth/rngx;
/*
c---  Total mass is ngz/ng so that the mean density = 1
*/
    pmas  = pow(nspace,3);
    pmass = pmas/rngc;

    wavemax = 1000;
/*
    if(size.lt.33)wavemax = 300
*/
    pamp = qsimp(bpowint,0.0001,wavemax);
    if(myid == 0) printf(" <1>, <k^2>= %g %g\n",pamp,pamp2);
	/*
      Here pamp = initial ms of top-hat smoothed density fluctuation
      pamp = 50.06, 800.95, 12815 for 64, 128, 256 h^-1 Mpc
      Now pamp*sqrt(P(k)) give rms fluctuation equal to thamp initially.
      After the expansion factor grows by the factor anow, the linear
      amplitude of fluctuation  will be (1/bias) over the scale rth.
      I. Einstein-de Sitter model
	*/
    if(omep == 1.){ 
		pamp = (1./bias)/sqrt(pamp)*ai/anow; 
		vamp = 1; 
	}
	  /*
      II. Open model
	  */
    else if(omep < 1 && omeplam == 0.){
        xnow = (1.-omep)/omep;
        xini = xnow/(1.+zi);
        bini = 1.+3./xini+3.*sqrt(1.+xini)/pow(xini,1.5)*log(sqrt(1.+xini)
              -sqrt(xini));
        bnow = 1.+3./xnow+3.*sqrt(1.+xnow)/pow(xnow,1.5)*log(sqrt(1.+xnow)
              -sqrt(xnow));
        pamp = (1./bias)/sqrt(pamp)*bini/bnow;
        vamp = pow(omei,0.6);
	}
	/*
      III. Zero curvature with cosmological constant model
	*/
    else if(omep < 1 && omeplam>0){
        bini = growth(1.,  amax,omep);
        bnow = growth(amax,amax,omep);
        pamp = (1./bias)/sqrt(pamp)*bini/bnow;
        vamp = (growth(1.+0.005,amax,omep)-growth(1.-0.005,amax,omep))
			/(0.01)*1./bini;
        if(myid == 0) {
           printf(" %g bini= %g, bnow= %g ,  %g",omep,bini,bnow,vamp);
		}
	}
    efold = 0.585*sqrt(2.);
    sfac   = -pow(pi*efold/size,2);
	/* Velocity Potential */
	pamp = pamp*rngzc*sqrt(xyz*xyy)*sqrt(0.5);
	for(i=0;i<=nhx;i++){
		for(j=0;j<ny;j++){
			ky = xyy*j;
			if(ky > nhy) ky = ky - ny;
			for(k=0;k<local_nz;k++){
				kz = xyz*(k+local_z_start);
				if(kz > ngz) kz = kz -nz;
				xksq = i*i+ky*ky+kz*kz;
				if(xksq == 0 || xksq > rknyq2){
					den(2*i+1,j,k) = 0.;
					den(2*i+2,j,k) = 0.;
				}
				else {
					rk = twopi*sqrt(xksq);
					velpot = pamp*bpower(rk)/(rk*rk);
					den(2*i+1,j,k) = velpot*gasdev(&iiseed);
					den(2*i+2,j,k) = velpot*gasdev(&iiseed);
				}
			}
		}
	}
    if(myid == 0) printf("last #= %g \n",ran3(&iiseed));
    if(myid == 0) printf(" rngzc = %g , rincube =%g\n",rngzc, rincube);
	for(k=0;k<local_nz;k++)
		for(j=0;j<ny;j++)
			for(i=0;i<2;i++)
				denpad(i,j,local_z_start+k) = den(i,j,k);
	if(myid == 0) {
		for(i=1;i<nid;i++){
			printf("get data from = %d",i);
			MPI_Recv(&mlocalstartz,1,MPI_INT,i,0,MPI_COMM_WORLD,&status);
			MPI_Recv(&mlocalnz,1,MPI_INT,i,0,MPI_COMM_WORLD,&status);
			MPI_Recv(denpad+(long)mx*(long)ny*(long)mlocalstartz,
					2*ny*mlocalnz,MPI_FLOAT,i,0,MPI_COMM_WORLD,&status);
			printf("got data from = %d\n",i);fflush(stdout);

		}
	}
	else {
		MPI_Send(&local_z_start,1,MPI_INT,0,0,MPI_COMM_WORLD);
		MPI_Send(&local_nz,1,MPI_INT,0,0,MPI_COMM_WORLD);
		MPI_Send(denpad+(long)mx*(long)ny*(long)local_z_start,
				2*ny*local_nz,MPI_FLOAT,0,0,MPI_COMM_WORLD);
		printf("P%d sent data to 0\n",myid);fflush(stdout);
	}
    printf("now after denpad commun\n");
	/* Satisfy complex conjugation relation for a real array */
	if(myid == 0) {
		for(k=1;k<nhz;k++){
			denpad(0,0,nz-k) =  denpad(0,0,k);
			denpad(1,0,nz-k) = -denpad(1,0,k);
			for(j=1;j<nhy;j++){
				denpad(0,ny-j,nz-k) =  denpad(0,j,k);
				denpad(1,ny-j,nz-k) = -denpad(1,j,k);
			}
		}
		for(j=1;j<nhy;j++){
			denpad(0,ny-j,0) =  denpad(0,j,0);
			denpad(1,ny-j,0) = -denpad(1,j,0);
		}
		for(k=1;k<nhz;k++)
			for(j=nhy+1;j<ny;j++){
				denpad(0,ny-j,nz-k) =  denpad(0,j,k);
				denpad(1,ny-j,nz-k) = -denpad(1,j,k);
			}
	}
    printf("P%d now before denpad broadcasting\n",myid);
	sendsize = 2*ny*nz;
	MPI_Bcast(denpad,sendsize,MPI_FLOAT,0,MPI_COMM_WORLD);
	for(k=0;k<local_nz;k++)
		for(j=0;j<ny;j++)
			for(i=0;i<2;i++)
				den(i,j,k) = denpad(i,j,local_z_start+k);
    printf("P%d now after denpad broadcasting\n",myid);
	for(i=0;i<=nhx;i++){
		for(j=0;j<ny;j++){
			ky = xyy*j;
			if(ky> nhy) ky = ky -ny;
			for(k=0;k<local_nz;k++){
				kz = xyz*(k+local_z_start);
				if(kz > nhz) kz = kz -nz;
				fx(2*i  ,j,k) = -twopi*i*den(2*i+1,j,k);
				fx(2*i+1,j,k) =  twopi*i*den(2*i  ,j,k);
				fy(2*i  ,j,k) = -twopi*ky*den(2*i+1,j,k);
				fy(2*i+1,j,k) =  twopi*ky*den(2*i  ,j,k);
				fz(2*i  ,j,k) = -twopi*kz*den(2*i+1,j,k);
				fz(2*i+1,j,k) =  twopi*kz*den(2*i  ,j,k);
			}
		}
	}
	if(myid == 0) printf("getting force array in x-dim\n");
	rfftwnd_mpi(iplan,1,(fftw_real *)fx,NULL,FFTW_NORMAL_ORDER);
	if(myid == 0) printf("getting force array in y-dim\n");
	rfftwnd_mpi(iplan,1,(fftw_real *)fy,NULL,FFTW_NORMAL_ORDER);
	if(myid == 0) printf("getting force array in z-dim\n");
	rfftwnd_mpi(iplan,1,(fftw_real *)fz,NULL,FFTW_NORMAL_ORDER);
	for(k=0;k<local_nz;k++)
		for(j=0;j<ny;j++)
			for(i=0;i<nx;i++){
				fx(i,j,k) *= rincube;
				fy(i,j,k) *= rincube;
				fz(i,j,k) *= rincube;
			}
	vfact = vamp;
#ifdef INITIALREADING
	printf("{%d now in the random initial positions %d\n",myid,np);
    sendsize = 2*(nx/2+1)*ny*2;
    recvsize = 2*(nx/2+1)*ny*2;
    dest = (myid+1+nid)%nid;
    src = (myid-1+nid)%nid;
    stag = 0
    rtag = 0
	MPI_Sendrecv(fx+(long)mx*(long)ny*(long)(local_nz-2),sendsize,MPI_FLOAT,
			dest,stag,fx+(long)mx*(long)ny*(long)(local_nz+5),recvsize,
			MPI_FLOAT,src,rtag,MPI_COMM_WORLD,&status);
	MPI_Sendrecv(fy+(long)mx*(long)ny*(long)(local_nz-2),sendsize,MPI_FLOAT,
			dest,stag,fy+(long)mx*(long)ny*(long)(local_nz+5),recvsize,
			MPI_FLOAT,src,rtag,MPI_COMM_WORLD,&status);
	MPI_Sendrecv(fz+(long)mx*(long)ny*(long)(local_nz-2),sendsize,MPI_FLOAT,
			dest,stag,fz+(long)mx*(long)ny*(long)(local_nz+5),recvsize,
			MPI_FLOAT,src,rtag,MPI_COMM_WORLD,&status);
	dest = (myid-1+nid)%nid;
	src = (myid+1+nid)%nid;
	MPI_Sendrecv(fx,sendsize,MPI_FLOAT,dest,stag,
			fx+(long)mx*(long)ny*(long)local_nz,recvsize,MPI_FLOAT,src,rtag,
			MPI_COMM_WORLD,&status);
	MPI_Sendrecv(fy,sendsize,MPI_FLOAT,dest,stag,
			fy+(long)mx*(long)ny*(long)local_nz,recvsize,MPI_FLOAT,src,rtag,
			MPI_COMM_WORLD,&status);
	MPI_Sendrecv(fz,sendsize,MPI_FLOAT,dest,stag,
			fz+(long)mx*(long)ny*(long)local_nz,recvsize,MPI_FLOAT,src,rtag,
			MPI_COMM_WORLD,&status);
	nz_per = local_nz+7;
	start_z = local_z_start;
	for(bp = particles;bp<particles+np;bp++){
		xp = bp->x;
		yp = bp->y;
		zp = bp->z-start_z;
		nearx = rint(xp);
		neary = rint(yp);
		nearz = rint(zp);
		xmin = xp - nearx;
		ymin = yp - neary;
		zmin = zp - nearz;
		xsign = sign(1.,xmin);
		ysign = sign(1.,ymin);
		zsign = sign(1.,zmin);
		i1 = (nearx+nx)%(nx);
		j1 = (neary+ny)%(ny);
		k1 = (nearz+nz_per)%(nz_pear);
		i2 = (nearx+nx+xsign)%(nx);
		j2 = (neary+ny+ysign)%(ny);
		k2 = (neark+nz_per+zsign)%(nz_per);
		i3 = (nearx+nx-xsign)%(nx);
		j3 = (neary+ny-ysign)%(ny);
		k3 = (nearz+nz_per-zsign)%(nz_per);
		xd1 = fabs(xmin);
		yd1 = fabs(ymin);
		zd1 = fabs(zmin);
		wx1 = 0.75-xd1*xd1;
		wy1 = 0.75-yd1*yd1;
		wz1 = 0.75-zd1*zd1;
		wx2 = 0.5*(0.5+xd1)*(0.5+xd1);
		wy2 = 0.5*(0.5+yd1)*(0.5+yd1);
		wz2 = 0.5*(0.5+zd1)*(0.5+zd1);
		wx3 = 0.5*(0.5-xd1)*(0.5-xd1);
		wy3 = 0.5*(0.5-yd1)*(0.5-yd1);
		wz3 = 0.5*(0.5-zd1)*(0.5-zd1);
        wt1  = wx1*wy1*wz1;
        wt2  = wx2*wy1*wz1;
        wt3  = wx3*wy1*wz1;
        wt4  = wx1*wy2*wz1;
        wt5  = wx2*wy2*wz1;
        wt6  = wx3*wy2*wz1;
        wt7  = wx1*wy3*wz1;
        wt8  = wx2*wy3*wz1;
        wt9  = wx3*wy3*wz1;
        wt10 = wx1*wy1*wz2;
        wt11 = wx2*wy1*wz2;
        wt12 = wx3*wy1*wz2;
        wt13 = wx1*wy2*wz2;
        wt14 = wx2*wy2*wz2;
        wt15 = wx3*wy2*wz2;
        wt16 = wx1*wy3*wz2;
        wt17 = wx2*wy3*wz2;
        wt18 = wx3*wy3*wz2;
        wt19 = wx1*wy1*wz3;
        wt20 = wx2*wy1*wz3;
        wt21 = wx3*wy1*wz3;
        wt22 = wx1*wy2*wz3;
        wt23 = wx2*wy2*wz3;
        wt24 = wx3*wy2*wz3;
        wt25 = wx1*wy3*wz3;
        wt26 = wx2*wy3*wz3;
        wt27 = wx3*wy3*wz3;
        bp->vx = (wt1 *fx(i1,j1,k1)+wt2 *fx(i2,j1,k1)+wt3 *fx(i3,j1,k1)+
             wt4 *fx(i1,j2,k1)+wt5 *fx(i2,j2,k1)+wt6 *fx(i3,j2,k1)+
             wt7 *fx(i1,j3,k1)+wt8 *fx(i2,j3,k1)+wt9 *fx(i3,j3,k1)+
             wt10*fx(i1,j1,k2)+wt11*fx(i2,j1,k2)+wt12*fx(i3,j1,k2)+
             wt13*fx(i1,j2,k2)+wt14*fx(i2,j2,k2)+wt15*fx(i3,j2,k2)+
             wt16*fx(i1,j3,k2)+wt17*fx(i2,j3,k2)+wt18*fx(i3,j3,k2)+
             wt19*fx(i1,j1,k3)+wt20*fx(i2,j1,k3)+wt21*fx(i3,j1,k3)+
             wt22*fx(i1,j2,k3)+wt23*fx(i2,j2,k3)+wt24*fx(i3,j2,k3)+
             wt25*fx(i1,j3,k3)+wt26*fx(i2,j3,k3)+wt27*fx(i3,j3,k3))
             *vfact;
        bp->vy = (wt1 *fy(i1,j1,k1)+wt2 *fy(i2,j1,k1)+wt3 *fy(i3,j1,k1)+
             wt4 *fy(i1,j2,k1)+wt5 *fy(i2,j2,k1)+wt6 *fy(i3,j2,k1)+
             wt7 *fy(i1,j3,k1)+wt8 *fy(i2,j3,k1)+wt9 *fy(i3,j3,k1)+
             wt10*fy(i1,j1,k2)+wt11*fy(i2,j1,k2)+wt12*fy(i3,j1,k2)+
             wt13*fy(i1,j2,k2)+wt14*fy(i2,j2,k2)+wt15*fy(i3,j2,k2)+
             wt16*fy(i1,j3,k2)+wt17*fy(i2,j3,k2)+wt18*fy(i3,j3,k2)+
             wt19*fy(i1,j1,k3)+wt20*fy(i2,j1,k3)+wt21*fy(i3,j1,k3)+
             wt22*fy(i1,j2,k3)+wt23*fy(i2,j2,k3)+wt24*fy(i3,j2,k3)+
             wt25*fy(i1,j3,k3)+wt26*fy(i2,j3,k3)+wt27*fy(i3,j3,k3))
             *vfact;
        bp->vz = (wt1 *fz(i1,j1,k1)+wt2 *fz(i2,j1,k1)+wt3 *fz(i3,j1,k1)+
             wt4 *fz(i1,j2,k1)+wt5 *fz(i2,j2,k1)+wt6 *fz(i3,j2,k1)+
             wt7 *fz(i1,j3,k1)+wt8 *fz(i2,j3,k1)+wt9 *fz(i3,j3,k1)+
             wt10*fz(i1,j1,k2)+wt11*fz(i2,j1,k2)+wt12*fz(i3,j1,k2)+
             wt13*fz(i1,j2,k2)+wt14*fz(i2,j2,k2)+wt15*fz(i3,j2,k2)+
             wt16*fz(i1,j3,k2)+wt17*fz(i2,j3,k2)+wt18*fz(i3,j3,k2)+
             wt19*fz(i1,j1,k3)+wt20*fz(i2,j1,k3)+wt21*fz(i3,j1,k3)+
             wt22*fz(i1,j2,k3)+wt23*fz(i2,j2,k3)+wt24*fz(i3,j2,k3)+
             wt25*fz(i1,j3,k3)+wt26*fz(i2,j3,k3)+wt27*fz(i3,j3,k3))
             *vfact;
	}
#else
	findindex_(particles,&nx,&ny,&local_nz,&nspace,&np,&nid);
	for(k=0;k<local_nz/nspace;k++)
		for(j=0;j<ny/nspace;j++)
			for(i=0;i<nx/nspace;i++){
				iindex = i+nx/nspace*(j+ny/nspace*k);
				particles[iindex].x = nspace*i;
				particles[iindex].y = nspace*j;
				particles[iindex].z = nspace*k+local_z_start;
				ii = nspace*i;
				jj = nspace*j;
				kk = nspace*k;
				particles[iindex].vx = vfact*fx(ii,jj,kk);
				particles[iindex].vy = vfact*fy(ii,jj,kk);
				particles[iindex].vz = vfact*fz(ii,jj,kk);
			}
#endif
	/* For (n,size,seed)=(64,64,17), vx(1,1,1)=-0.0051 & vy(1,1,1)=-0.0049 */
	/*
      Push : position at a=ai (dx/da is constant from a=0 to ai)
      Displacement from ai*dx/da at particle position
      pfact = rng*ai*omei**(-0.6)
	*/
    pfact = rngx*ai/vamp;
    delx = 0.L;
    displ = 0;
    mdispl = 0.;
	for(bp=particles;bp<particles+np;bp++){
		float vdisp;
		bp->x = fmod(bp->x+bp->vx*pfact+rnx,rnx);
		bp->y = fmod(bp->y+bp->vy*pfact+rny,rny);
		bp->z = fmod(bp->z+bp->vz*pfact+rnz,rnz);
		vdisp = bp->vx*bp->vx + bp->vy*bp->vy+bp->vz*bp->vz;
		delx += vdisp;
		displ = sqrt(vdisp)*pfact;
		mdispl = MAX(displ,mdispl);
#ifndef VarPM
		bp->freework = 1.;
#endif
	}
	printf("maximum displacement at initial condition=%g\n",mdispl);
	MPI_Reduce(&delx,&tdelx,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
	delx = tdelx;
	MPI_Bcast(&delx,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
	lnp = np;
	MPI_Reduce(&lnp,&tlnp,1,MPI_LONG,MPI_SUM,0,MPI_COMM_WORLD);
	MPI_Bcast(&tlnp,1,MPI_LONG,0,MPI_COMM_WORLD);
	if(myid==0) printf("P%d delx=%g pfact=%g tlnp=%ld\n",myid,delx,pfact,tlnp);
	if(myid==0) printf("rms displacement=%g\n",dsqrt(delx)*pfact/
			sqrt((float)(tlnp)));
	/* relative displacement */
	rdzmean = 0.;
	rdzstd = 0.;
	rdzmin = 1.e20;
	rdzmax = -1.e20;
	for(i=0;i<np-nx*ny;i++){
		int ntmp;
		ntmp = i + nx*ny;
		rdz = particles[ntmp].z-particles[i].z-1.;
		rdzmin = MIN(rdz,rdzmin);
		rdzmax = MIN(rdz,rdzmax);
		rdzmean += rdz;
		rdzstd += rdz*rdz;
	}
	rdzmean = rdzmean/(float)np;
	rdzstd = rdzstd/(float)np - rdzmean*rdzmean;
	rdzstd = sqrt(rdzstd);
	printf("Relative dz: min= %g max = %g\n",rdzmin,rdzmax);
	printf("Relative dz: mean= %g std = %g\n",rdzmean,rdzstd);
	/* Energy */
	tmpken = 0.L;
	for(bp=particles;bp<particles+np;bp++){
#ifdef MULTIMASS
		tmpken += bp->mass*(bp->vx*bp->vx+bp->vy*bp->vy+bp->vz*bp->vz);
#else
		tmpken += (bp->vx*bp->vx+bp->vy*bp->vy+bp->vz*bp->vz);
#endif
	}
	MPI_Reduce(&tmpken,&tken,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
	tmpken = tken;
	MPI_Bcast(&tmpken,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
	if(myid == 0) {
		printf("sum of dx/da**2=%g",tmpken);
      	tmpken=0.5L*8.L*PI/3.L*(1.L/ai+1.L/omei-1.L)*tmpken;
		ktot = 0.;
		poten = 0.;
		constant = ai*ai*ai*tmpken+poten+ktot;
		printf("poten=%g ken=%g const=%g\n",poten,tmpken,constant);
	}
    ken = tmpken;
	if(myid==0) TIMER_STOP(22);
	if(myid == 0) printf("Generating Initial Condition %g\n",ELAPSED_TIME(22));
}

/*
c---  Growth factor in the universe with zero curvature
c---  omep= present matter density parameter
c---  omeplam = 1-omep is assumed (zero curvature inflation model)
c     function growth(a,amax,omep)
c     external coscon
c     common/pass/x

c     x0 = (1./omep-1)**(1./3.)
c     red = amax/a-1
c     x = (1./omep-1)**(1./3.)/(1+red)
c     call qsimp(coscon,0.,1.,gfac)
c     growth = (x/x0)*sqrt(x**3+1)*gfac
c     return
c     end

c     function coscon(y)
c     common/pass/x
c     coscon = 1./(sqrt(1+x**3*y**1.2))**3
c     return
c     end


*/
