#
# Makefile for PM/Tree code pyul.exe - April 23, 2001 - JJD
#


#AR = ar -X64 rcv
AR = ar rcv
RANLIB = ranlib
#OPT = -O3 -q64 -qtune=pwr4 -qarch=pwr4
#OPT = -pc 80 -mp -mcmodel=medium -Mlarge_arrays -tp k8-64 -O3 -fastsse -Mnontemporal 
#OPT = -mp -Msmartalloc=huge -lnuma -pc 80  -Mlarge_arrays -O3 -fastsse -Mnontemporal  #-Mipa=fast #-tp barcelona-64
#OPT = -mp -fast -Msmartalloc=huge -lnuma -pc 80  -mcmodel=medium -Mlarge_arrays -O3 -fastsse -Mnontemporal  -Mipa=fast #-tp barcelona-64
#OPT = -O3    -openmp
#OPT = -O3  -ipo -no-prec-div -xP -mtune=pentium-mmx -ftz -ip -opt-mem-bandwidth2
#OPT = -O1 -xP -ip
OPT = -pc 80 -mcmodel=medium -Mlarge_arrays -tp k8-64 -O1 -Mnontemporal 
#OPT = -openmp -O3 -fast 
#OPT = -O3
#OPT = -Mprof=mpi,func 

#############################################
# List of compilation directives
#############################################
# 
# -DNTREEMIN=nnn  - minimum number of particles in tree - default NTREEMIN=4
# -DNMEG=nnn      - number of megabytes of storage per processor - default=40
# -DINCLUDE_TREE_FORCE - define if you want tree code corrections
# -DTREE               - define if you want tree code corrections
# -DDEBUG              - output debugging information
# -DBIT64              - use on machines using 64 bit addressing 
#                       - i.e. Compaq alpha
# -DAIX                - use on IBM SP3 machines
# -DOBSERVATION_MODE   - save halo data at every ObservationStride'th step
# -DSAVESLICE          - save slice density file at every time step
# -DEH98          - Use the Eisenstein & Hu (1998) fitting power spectrum
######################################################
# CURRENTLY NOT CHECKED - April 23, 2001 - jjd
#############################################################
# -DENOUGH_SPACE   : if there is enough space for memory
#    -DFDA_FORCE_ARRAY_SWP  : force array + swap space
#    -DTSC_SWAP : tsc swap
#############################################################
#
#####################################
# System specific definitions
#####################################
# LINUX
#####################################
#FC = mpif77
#CC = mpicc
#INCLUDES = -I/user/kjhan/local/include
#
##FDFLAGS = -DINCLUDE_TREE_FORCE 
#DFLAGS = -DNMEG=350 -DCORRELATION_FUNCTION \
#	-DTREEFIX -Dkjhr -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE \
#	-DOBSERVATION_MODE  -DPMSEEDFORCE 
#	 #  -DSAVESLICE  -DSURVEY \
#	# -DINCLUDE_TREE_FORCE -DTREE
#FFLAGS = $(FDFLAGS) $(OPT)
#CFLAGS = $(OPT) $(DFLAGS)  
#LDFLAGS = $(OPT)
#LIBS = -L/user/kjhan/local/lib/ -L./PREWORK -L./WORKNEW \
#	-lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw \
#	-lm -lpre -lhfind 
##################################
# PG Compiler
##################################
#FC = mpif77 
#CC = mpicc
#INCLUDES = -I/home/g004cbp/local64/include
#
## 64 bits flag #############
#FDFLAGS = -DBIT64 -DINCLUDE_TREE_FORCE -DVarPM -DINITIALREADING 
##-WF,-DACCOUT -DINDVEPS
#DFLAGS = -Bstatic -DNMEG=800L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \
#	-DLONGINDEX -DINCLUDE_TREE_FORCE -DTREE \
#	-DTREEFIX  -D_LARGE_FILES -DSAVESLICE \
#	-DNEW_SAVING_IN_PREWORK -DOBSERVATION_MODE   -DVarPM -DSIMPLESURVEY\
#	-DINITIALREADING
#
#FFLAGS = $(FDFLAGS) $(OPT) 
#CFLAGS = $(OPT) $(DFLAGS)  
#LDFLAGS = $(OPT) 
#LIBS = -L/home/kjhan/fftw/lib/ -L./PREWORK -L./WORKNEW \
#	-lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw \
#	-lm -lhfind -lpre
##################################
# Linux PGI Compiler
##################################
#COMPILER = PGI
#FC = /opt/openmpi/1.2.6/Intel10.1/bin/mpif77 
#CC = /opt/openmpi/1.2.6/Intel10.1/bin/mpicc 
#FC = mpif77
FC = mpif90
CC = mpicc
F90C = pgf90
#INCLUDES = -I/home01/e994pcb/local/include

INCLUDES = -I/user/kjhan/fftwfinal/include

F90INCLUDES = -I./$(CAMBDIR)/
#INCLUDES = -I/home/kjhan/local_openmpi/include/

# 64 bits flag #############
COMFLAGS = -DNNX=4180 -DNNY=4180 -DNNZ=4180 -DLOCAL_NNZ=128 -DNPROCS=824


#FDFLAGS =  -DFFTW_DIVISIBLE_SIZE=1024 -DBIT64 -DINCLUDE_TREE_FORCE -DVarPM  -DCOMPILER=PGI #-DINDEX
#FDFLAGS =  -DBIT64 -DINCLUDE_TREE_FORCE -DVarPM  -DCOMPILER=PGI -DINDEX
FDFLAGS =  -DBIT64 -DINCLUDE_TREE_FORCE -DVarPM   -DINDEX   #-DEH98

#-WF,-DACCOUT -DINDVEPS
#CDFLAGS = -DNMEG=6900L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \

#CDFLAGS = -DNMEG=3450L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \


#CDFLAGS = -DNMEG=7300L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \

#CDFLAGS = -DNMEG=3210L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \
#CDFLAGS = -DNMEG=3550L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \

CDFLAGS = -DNMEG=3300L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 \
		-DINCLUDE_TREE_FORCE -DTREE \
        -DTREEFIX  -D_LARGE_FILES -DSAVESLICE \
        -DOBSERVATION_MODE   -DVarPM -DPMSEEDFORCE\
		-DINDEX -DLAM

		#-DDEBUG  #-DINDEX 

#		-DSIMPLESURVEY\
#        -DINITIALREADING  
# -DPMSEEDFORCE -DDEBUG

FFLAGS = $(FDFLAGS) $(OPT) $(COMFLAGS)  
CFLAGS = $(OPT) $(CDFLAGS)  $(COMFLAGS) 
LDFLAGS = $(OPT) 
#LIBS = -L/home01/e994pcb/local/lib/\

CAMBLIBS = -L./$(CAMBDIR) -lcamb
LIBS = -L/user/kjhan/fftwfinal/lib/ -lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw   $(CAMBLIBS) 
#LIBS = -L/home/kjhan/local_openmpi/lib -lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw 




#FC = mpxlf_r
#CC = mpcc_r
#INCLUDES = -I/home/g004cbp/local64/include

# 64 bits flag #############
#FDFLAGS = -WF,-DAIX -WF,-DBIT64 -WF,-DCOMPACT -WF,-DINCLUDE_TREE_FORCE #-WF,-DACCOUT
#DFLAGS = -DNMEG=5500L -DCORRELATION_FUNCTION -Dkjhr  -DBIT64 -DCOMPACT \
#	-DMULTIMASS -DLONGINDEX \
#	-DINCLUDE_TREE_FORCE -DTREE \
#	-DTREEFIX  -D_LARGE_FILES -DSAVESLICE \
#	-DOBSERVATION_MODE -DPMSEEDFORCE  -DNEW_SAVING_IN_PREWORK  -DSURVEY \
#	 #-DACCOUT
#FFLAGS = $(FDFLAGS) $(OPT) -qextname 
#CFLAGS = $(OPT) $(DFLAGS)  
#LDFLAGS = $(OPT) 
#LIBS = -L/home/g004cbp/local64/lib/ -L./PREWORK -L./WORKNEW \
#	-lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw \
#	-lm -lmpi -lhfind -lpre

# 32 bits flag #############
#FFLAGS = $(FDFLAGS) $(OPT) -qextname -q32 -qtune=pwr3 -qarch=pwr3 -bmaxdata:2000000000 -bmaxstack:2000000000
#CFLAGS = $(OPT) $(DFLAGS)  -q32 -qtune=pwr3 -qarch=pwr3 -bmaxdata:2000000000 -bmaxstack:2000000000
#LDFLAGS = $(OPT) -qextname -q32 -qtune=pwr3 -qarch=pwr3 -bmaxdata:2000000000 -bmaxstack:2000000000

#################################
# Compaq Alpha
#################################
#FC = f77
#CC = cc 
#INCLUDES = -I/home/kjhan/dolphin/fftw/include
#FDFLAGS = -DBIT64 -DINCLUDE_TREE_FORCE -DTREE -DCOMPACT
#DFLAGS = -DBIT64 -DNMEG=256 -DINCLUDE_TREE_FORCE -DTREE -DCOMPACT -DTREEFIX
#FFLAGS = $(FDFLAGS)  -fast -nofor_main
#CFLAGS = $(DFLAGS)  -fast
#LDFLAGS =  -fast -nofor_main
#LIBS = -L/home/kjhan/dolphin/fftw/lib -lsrfftw_mpi -lsfftw_mpi -lsrfftw -lsfftw -lm -lz -lmpi -lm
##################################

#--- C Compiler information
#  Leave the rest untouched


#--- Suffix-based compilation rules
.SUFFIXES: .exe .o .c .f .F .f90

#rules to build binary from source


.c.o :
	$(CC) $(CFLAGS) $(INCLUDES) -c $<

.f90.o :
	$(F90C) $(FFLAGS) $(INCLUDES) $(F90INCLUDES) -c $<

.f.o :
	$(FC) $(FFLAGS) $(INCLUDES) -c $<

.for.o :
	$(FC) $(FFLAGS) $(INCLUDES) -c $<

.F.o :
	$(FC) $(FFLAGS) $(INCLUDES) -c $<

.c.exe :
	$(FC) $(LDFLAGS) $(INCLUDES) -o $*.exe $(OBJS) $(MPI_LINKS) $(LIBS)

.f.exe :
	$(FC) $(LDFLAGS) $(INCLUDES) -o $*.exe $(OBJS) $(MPI_LINKS) $(LIBS) $(INCLUDES)

.f90.exe :
	$(F90C) $(LDFLAGS) $(INCLUDES) -o $*.exe $(OBJS) $(MPI_LINKS) $(LIBS) $(INCLUDES)

.for.exe :
	$(FC) $(LDFLAGS) $(INCLUDES) -o $*.exe $(OBJS) $(MPI_LINKS) $(LIBS) $(INCLUDES)

.F.exe :
	$(FC) $(LDFLAGS) $(INCLUDES) -o $*.exe $(OBJS) $(MPI_LINKS) $(LIBS) $(INCLUDES)

#--- Targets
