/* This makes Tree structure and walks along tree structures.
 * For performance issue it is needed to check which one is better,
 * 2*a or a+a.
 * */
#include<stdio.h>
#include<stdlib.h>
#include<stddef.h>
#include<math.h>
#include "pmheader.h"
#include "kjhtree.h"
#include "force_spline.h"
double pmcf(double);
#define MIN(A,B) ((A)<(B) ? (A):(B))
#define MAX(A,B) ((A)>(B) ? (A):(B))
extern forceprecision diff[NSPLINE][3],slope[NSPLINE][3],ran2nran,invran2nran;
enum boolean fof_open(particle p,FoFTStruct *tree, float fof_link){
	register float tmpx,tmpy,tmpz; 
	register float dist2,dist,r,diff; 
	register float ratio; 
	tmpx = p.x-tree->mono[0]; 
	tmpy = p.y-tree->mono[1]; 
	tmpz = p.z-tree->mono[2]; 
	r = tree->dist;
	dist2 = ((tmpx*tmpx)+tmpy*tmpy)+tmpz*tmpz; 
	dist = sqrt(dist2);
	diff = dist - r;
	if(diff <= fof_link) return YES;
	else return NO;
}
inline enum boolean cellopen(particle *p,TStruct *tree){
	register float tmpx,tmpy,tmpz; 
	register float dist2; 
	register float ratio; 
	tmpx = p->x-tree->mono[0]; 
	tmpy = p->y-tree->mono[1]; 
	tmpz = p->z-tree->mono[2]; 
	dist2 = ((tmpx*tmpx)+tmpy*tmpy)+tmpz*tmpz; 
	/*
	ratio = tree->dist2/theta2; 
	if(dist2 < ratio) return YES;
	*/
	if(dist2 < tree->dist_over_thetasq) return YES;
	else return NO;
}
#define CELLFORCE(p,ptr,rspheresq) \
{\
	pointer = (TStruct *) ptr;   \
	tmpx = (p->x)-(pointer->mono[0]);\
	tmpy = (p->y)-(pointer->mono[1]);\
	tmpz = (p->z)-(pointer->mono[2]);\
	dist2 = ((tmpx*tmpx) + tmpy*tmpy) + tmpz*tmpz;   \
	if(dist2 <= rspheresq){\
		dist=sqrt(dist2);\
		/* \
		ntmp = dist/ran2nran;   \
		*/\
		ntmp = dist*invran2nran;   \
		Qxx = pointer->quad[0];\
		Qyy = pointer->quad[1];\
		Qzz = pointer->quad[2];\
		Qxy = pointer->quad[3];\
		Qxz = pointer->quad[4];\
		Qyz = pointer->quad[5];\
		trQ = (Qxx + Qyy + Qzz);   \
		qxx1 = ((Qxx*tmpx)+Qxy*tmpy)+Qxz*tmpz;   \
		qxx2 = ((Qxy*tmpx)+Qyy*tmpy)+Qyz*tmpz;   \
		qxx3 = ((Qxz*tmpx)+Qyz*tmpy)+Qzz*tmpz;   \
		qxy = Qxx*tmpx*tmpx+Qyy*tmpy*tmpy+Qzz*tmpz*tmpz+   \
			2*(Qxy*tmpx*tmpy+Qxz*tmpx*tmpz+Qyz*tmpy*tmpz); \
		tmpdist = (dist-ntmp*ran2nran);   \
		ntmp = MIN(ntmp,NSPLINE-1);\
		fplmf1 = diff[ntmp][0] + slope[ntmp][0]*tmpdist;   \
		fplmf2 = diff[ntmp][1] + slope[ntmp][1]*tmpdist;   \
		fplmf3 = diff[ntmp][2] + slope[ntmp][2]*tmpdist;   \
		tmptmp = pointer->mass*fplmf1 + trQ*fplmf2 + qxy*fplmf3;\
		twofplmf2 = fplmf2+fplmf2;\
		p->ax += tmpx*tmptmp+qxx1*twofplmf2; \
		p->ay += tmpy*tmptmp+qxx2*twofplmf2; \
		p->az += tmpz*tmptmp+qxx3*twofplmf2; \
	}\
}
#define PARTICLEFORCE(p,ptr,rspheresq) \
{ \
	ppointer = (TPtlStruct *) ptr; \
	ptlmass = ppointer->mass; \
	tmpx = p->x-ppointer->r[0];\
	tmpy = p->y-ppointer->r[1];\
	tmpz = p->z-ppointer->r[2];\
	dist2 = ((tmpx*tmpx) + tmpy*tmpy) + tmpz*tmpz;  \
	if(dist2 <= rspheresq){\
		dist = sqrt(dist2);\
		/* \
		ntmp = dist/ran2nran;  \
		*/\
		ntmp = dist*invran2nran;  \
		fplmf = diff[ntmp][0] + slope[ntmp][0] * (dist-ntmp*ran2nran);  \
		fplmf *= ptlmass; \
		p->ax +=  tmpx * fplmf;  \
		p->ay +=  tmpy * fplmf;  \
		p->az +=  tmpz * fplmf;  \
	}\
}


void inline treeforce(particle *p,float theta2,TStruct *tree, TPtlStruct *ptl,
		float rspheresq){
	void *ptr,*optr;
	int ntmp;   
	float tmpx,tmpy,tmpz,dist2,dist3,dist5,dist;   
	float Qxx,Qyy,Qzz,Qxy,Qxz,Qyz,trQ; 
	float qxx1,qxx2,qxx3,qxy,tmpdist;   
	float fplmf1,fplmf2,twofplmf2,fplmf3,fplmf4,tmptmp;   
	float fplmf;  
	TStruct *pointer;
	TPtlStruct *ppointer;   
	float ptlmass;
	ptr = (void *)tree;
	p->ax=p->ay=p->az = 0.;
	while(ptr != NULL){
		if(((TYPE*)ptr)->type == TYPE_TREE) {
			if(cellopen(p,ptr) == YES) 
				ptr = (void *)(((TStruct*)ptr)->daughter);
			else{
				CELLFORCE(p,ptr,rspheresq);
				ptr = (void *)(((TStruct*)ptr)->sibling);
			}
		}
		else{
			PARTICLEFORCE(p,ptr,rspheresq);
			ptr = (void*)(((TPtlStruct*)ptr)->sibling);
		}
	}
	return;
}
void FoF_Make_Tree(FoFTStruct *TREE_START,FoFTPtlStruct *ptl,int np,Box box){
	FoFBeginEndTree beginend;
	FoFTStruct *NewTree;
	FoFTPtlStruct *ptr;
	ptr = ptl;
	while(ptr != NULL){
		ptr->included = NO;
		ptr = ptr->sibling;
	}
	TREE_START->sibling = NULL;
	beginend = FoF_divide_node(TREE_START,TREE_START+1,ptl,box,TREE_START);
}
FoFBeginEndTree FoF_divide_node(FoFTStruct *TREE_START,FoFTStruct *NewTree, 
		FoFTPtlStruct *ptl, Box box,FoFTStruct *ThisTree){ 
	FoFBeginEndTree beginend;
	FoFTStruct *p2tree,tmpnode[8];
	FoFTStruct *NowCal;
	void *from_sibling;
	FoFTPtlStruct *p2ptl,*tmpptr,*tmpptr2;
	Box tmpbox[8];
	int i,j,k,mnode,mx,my,mz;
	float x0,y0,z0,inv_halfw,halfw;
	float tmpx,tmpy,tmpz,tmpdist2,distmax;
	float ptlmass;
	int count;
	ThisTree->type = TYPE_TREE;
	ThisTree->daughter = NULL;
	ThisTree->L = box.width;
	ThisTree->r0[0] = box.x;
	ThisTree->r0[1] = box.y;
	ThisTree->r0[2] = box.z;
	ThisTree->Nparticle = 0;
	ThisTree->mono[0]= ThisTree->mono[1]= ThisTree->mono[2]= 0.;

	p2ptl = ptl;
	while(p2ptl != NULL){
		ThisTree->Nparticle ++;
		ThisTree->mono[0] += p2ptl->r[0];
		ThisTree->mono[1] += p2ptl->r[1];
		ThisTree->mono[2] += p2ptl->r[2];
		p2ptl = p2ptl->sibling;
	}
	ThisTree->mono[0] /= ThisTree->Nparticle;
	ThisTree->mono[1] /= ThisTree->Nparticle;
	ThisTree->mono[2] /= ThisTree->Nparticle;
	distmax = -1.E20;
	p2ptl = ptl;
	while(p2ptl != NULL){
		tmpx = p2ptl->r[0] - ThisTree->mono[0];
		tmpy = p2ptl->r[1] - ThisTree->mono[1];
		tmpz = p2ptl->r[2] - ThisTree->mono[2];
		tmpdist2 = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;
		distmax = MAX(distmax,tmpdist2);
		p2ptl = p2ptl->sibling;
	}
	ThisTree->dist2 = distmax;
	ThisTree->dist = sqrt(distmax);
	x0 = box.x;
	y0 = box.y;
	z0 = box.z;
	halfw = box.width*0.5;
	inv_halfw = 1./halfw;
	for(i=0;i<8;i++) {
		tmpnode[i].sibling = tmpnode[i].daughter = NULL;
		tmpnode[i].Nparticle = 0;
		tmpbox[i].width = halfw;
		tmpbox[i].x = x0+(i%2)*halfw;
		tmpbox[i].y = y0+((i%4)/2)*halfw;
		tmpbox[i].z = z0+(i/4)*halfw;
	}
	p2ptl = ptl;
	while(p2ptl != NULL){
		mx = (int)((p2ptl->r[0] - x0)*inv_halfw);
		my = (int)((p2ptl->r[1] - y0)*inv_halfw);
		mz = (int)((p2ptl->r[2] - z0)*inv_halfw);
		mnode = mx + 2*my + 4*mz;
		tmpnode[mnode].Nparticle ++; 
		tmpptr = tmpnode[mnode].daughter;
		tmpptr2 = p2ptl->sibling;
		tmpnode[mnode].daughter = p2ptl;
		p2ptl->sibling = tmpptr;
		p2ptl = tmpptr2;
	}
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle > 0) break;
	}
	if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE 
			&& tmpbox[i].width >= MINWIDTH){
		ThisTree->daughter = (void *)(NewTree);
	}
	else {
		ThisTree->daughter = (void *) tmpnode[i].daughter ;
	}
	count = 0;
	NowCal = NewTree;
	from_sibling = NULL;
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE 
				&& tmpbox[i].width >= MINWIDTH){
			NewTree->daughter = tmpnode[i].daughter;
			if(from_sibling != NULL) 
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = NewTree;
			from_sibling = NewTree;
			NewTree++;
			count ++;
		}
		else if(tmpnode[i].Nparticle > 0 ){
			tmpptr = tmpnode[i].daughter;
			if(from_sibling != NULL) 
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = tmpptr;
			while(tmpptr != NULL){
				from_sibling = tmpptr;
				tmpptr = tmpptr->sibling;
			}
		}
	}
	((GENERAL_TPtl_POINTER*)from_sibling)->sibling = ThisTree->sibling;
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE
				&& tmpbox[i].width >= MINWIDTH){
			beginend = FoF_divide_node(TREE_START,NewTree,
					tmpnode[i].daughter, tmpbox[i],NowCal);
			NewTree = beginend.start;
			NowCal ++;
		}
	}
	beginend.start = NewTree;
	return beginend;
}

extern float theta;
float thetasq;
void Make_Tree(TStruct *TREE_START,TPtlStruct *ptl,long np,Box box){
	BeginEndTree beginend;
	long i;
	TStruct *NewTree;
	thetasq = theta*theta;
	TREE_START->sibling = NULL;
	for(i=0;i<np;i++) ptl[i].sibling = &ptl[i+1];
	ptl[np-1].sibling = NULL;
	beginend = divide_node(TREE_START,TREE_START+1,ptl,box,TREE_START);
}
BeginEndTree divide_node(TStruct *TREE_START,TStruct *NewTree, 
		TPtlStruct *ptl, Box box,TStruct *ThisTree){ 
	BeginEndTree beginend;
	TStruct *p2tree, tmpnode[8];
	TStruct *NowCal;
	void *from_sibling;
	TPtlStruct *p2ptl,*tmpptr,*tmpptr2;
	Box tmpbox[8];
	int i,j,k,mnode,mx,my,mz;
	float x0,y0,z0,inv_halfw,halfw;
	float tmpx,tmpy,tmpz,tmpdist2,distmax;
	float ptlmass;
	long ncount;

	ThisTree->type = TYPE_TREE;
	ThisTree->daughter = NULL;
	ThisTree->L = box.width;
	ThisTree->r0[0] = box.x;
	ThisTree->r0[1] = box.y;
	ThisTree->r0[2] = box.z;
	ThisTree->mass = 0;
	ThisTree->Nparticle = 0;
	ThisTree->mono[0]= ThisTree->mono[1]= ThisTree->mono[2]= 0.;
	ThisTree->quad[0] = ThisTree->quad[1] = ThisTree->quad[2] = 0.;
	ThisTree->quad[3] = ThisTree->quad[4] = ThisTree->quad[5] = 0.;
	ThisTree->mrr = 0.;

	p2ptl = ptl;
	while(p2ptl != NULL){
		ptlmass = p2ptl->mass;
		ThisTree->mass += ptlmass;
		ThisTree->Nparticle ++;
		ThisTree->mono[0] += ptlmass * p2ptl->r[0];
		ThisTree->mono[1] += ptlmass * p2ptl->r[1];
		ThisTree->mono[2] += ptlmass * p2ptl->r[2];
		p2ptl = p2ptl->sibling;
	}
	ThisTree->mono[0] /= ThisTree->mass;
	ThisTree->mono[1] /= ThisTree->mass;
	ThisTree->mono[2] /= ThisTree->mass;
	distmax = -1.E20;
	p2ptl = ptl;
	while(p2ptl != NULL){
		ptlmass = p2ptl->mass;
		tmpx = p2ptl->r[0] - ThisTree->mono[0];
		tmpy = p2ptl->r[1] - ThisTree->mono[1];
		tmpz = p2ptl->r[2] - ThisTree->mono[2];
		tmpdist2 = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;
		distmax = MAX(distmax,tmpdist2);
		ThisTree->mrr += ptlmass * tmpdist2;
		ThisTree->quad[0] += ptlmass * tmpx * tmpx;
		ThisTree->quad[1] += ptlmass * tmpy * tmpy;
		ThisTree->quad[2] += ptlmass * tmpz * tmpz;
		ThisTree->quad[3] += ptlmass * tmpx * tmpy;
		ThisTree->quad[4] += ptlmass * tmpx * tmpz;
		ThisTree->quad[5] += ptlmass * tmpy * tmpz;
		p2ptl = p2ptl->sibling;
	}
	ThisTree->dist2 = distmax;
	ThisTree->dist_over_thetasq = (distmax)/thetasq;
	p2ptl = ptl;
	x0 = box.x;
	y0 = box.y;
	z0 = box.z;
	halfw = box.width*0.5;
	inv_halfw = 1./halfw;
	for(i=0;i<8;i++) {
		tmpnode[i].sibling = tmpnode[i].daughter = NULL;
		tmpnode[i].Nparticle = 0;
		tmpbox[i].width = halfw;
		tmpbox[i].x = x0+(i%2)*halfw;
		tmpbox[i].y = y0+((i%4)/2)*halfw;
		tmpbox[i].z = z0+(i/4)*halfw;
	}

	while(p2ptl != NULL){
		mx = (int)((p2ptl->r[0] - x0)*inv_halfw);
		my = (int)((p2ptl->r[1] - y0)*inv_halfw);
		mz = (int)((p2ptl->r[2] - z0)*inv_halfw);
		mx = MIN(mx,1); my = MIN(my,1); mz = MIN(mz,1);
		mnode = mx + 2*my + 4*mz;
		tmpnode[mnode].Nparticle ++; 
		tmpptr = tmpnode[mnode].daughter;
		tmpptr2 = p2ptl->sibling;
		tmpnode[mnode].daughter = p2ptl;
		p2ptl->sibling = tmpptr;
		p2ptl = tmpptr2;
	}
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle > 0) break;
	}
	if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE
			&& tmpbox[i].width >= MINWIDTH){
		ThisTree->daughter = (void *)(NewTree);
	}
	else {
		ThisTree->daughter = (void *) tmpnode[i].daughter ;
	}
	ncount = 0;
	NowCal = NewTree;
	from_sibling = NULL;
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE
				&& tmpbox[i].width >= MINWIDTH){
			NewTree->daughter = tmpnode[i].daughter;
			if(from_sibling != NULL) 
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = NewTree;
			from_sibling = NewTree;
			NewTree++;
			ncount ++;
		}
		else if(tmpnode[i].Nparticle > 0 ){
			tmpptr = tmpnode[i].daughter;
			if(from_sibling != NULL) 
				((GENERAL_TPtl_POINTER*)from_sibling)->sibling = tmpptr;
			while(tmpptr != NULL){
				from_sibling = tmpptr;
				tmpptr = tmpptr->sibling;
			}
		}
	}
	((GENERAL_TPtl_POINTER*)from_sibling)->sibling = ThisTree->sibling;
	for(i=0;i<8;i++){
		if(tmpnode[i].Nparticle >= NODE_HAVE_PARTICLE
				&& tmpbox[i].width >= MINWIDTH){
			beginend = divide_node(TREE_START,NewTree,
					tmpnode[i].daughter, tmpbox[i],NowCal);
			NewTree = beginend.start;
			NowCal ++;
		}
	}
	beginend.start = NewTree;
	return beginend;
}
/*
#define OFFSET 0.0001
Box findbox(TPtlStruct *ptl, size_t nend){
	float xmin,ymin,zmin,xmax,ymax,zmax;
	float width;
	Box box;
	size_t i;
	box.x = box.y = box.z = 0.;
	xmax=ymax=zmax = -1.E25;
	xmin=ymin=zmin = 1.E25;
	for(i=0;i<nend;i++){
		xmin = MIN(xmin,ptl[i].r[0]);
		ymin = MIN(ymin,ptl[i].r[1]);
		zmin = MIN(zmin,ptl[i].r[2]);
		xmax = MAX(xmax,ptl[i].r[0]);
		ymax = MAX(ymax,ptl[i].r[1]);
		zmax = MAX(zmax,ptl[i].r[2]);
	}
	width = MAX(width,xmax-xmin);
	width = MAX(width,ymax-ymin);
	width = MAX(width,zmax-zmin);
	box.x = xmin;
	box.y = ymin;
	box.z = zmin;
	box.width = width;
	box.x = box.x -box.width*OFFSET;
	box.y = box.y -box.width*OFFSET;
	box.z = box.z -box.width*OFFSET;
	box.width = box.width + box.width*OFFSET*2.;
	return box;
}
#undef OFFSET
*/
