#include "defs.h"

MPI_Status receive_status;

MaximumExtent(NBasicParticles,BasicParticles,rmin0,rmax0)
int NBasicParticles;
basicparticletype *BasicParticles;
coordStruct *rmin0, *rmax0;
{
	coordStruct rmin, rmax;
	basicparticletype *p;

	p = BasicParticles;
	rmin.x = rmax.x = p->x;
	rmin.y = rmax.y = p->y;
	rmin.z = rmax.z = p->z;
	for(p=BasicParticles; p<BasicParticles+(size_t)NBasicParticles; p++) {
		if( rmin.x > p->x )
			rmin.x = p->x;
		if( rmin.y > p->y )
			rmin.y = p->y;
		if( rmin.z > p->z )
			rmin.z = p->z;
		if( rmax.x < p->x )
			rmax.x = p->x;
		if( rmax.y < p->y )
			rmax.y = p->y;
		if( rmax.z < p->z )
			rmax.z = p->z;
	}

	*rmin0 = rmin;
	*rmax0 = rmax;
}

BinExtent(pbin,rmin0,rmax0)
particleStruct *pbin;
coordStruct *rmin0, *rmax0;
{
	coordStruct rmin, rmax;
	particleStruct *p;

	p = pbin;
	rmin.x = rmax.x = p->r.x;
	rmin.y = rmax.y = p->r.y;
	rmin.z = rmax.z = p->r.z;
	for(p=pbin; p!=NULL; p=p->nextinbin) {
		if( rmin.x > p->r.x )
			rmin.x = p->r.x;
		if( rmin.y > p->r.y )
			rmin.y = p->r.y;
		if( rmin.z > p->r.z )
			rmin.z = p->r.z;
		if( rmax.x < p->r.x )
			rmax.x = p->r.x;
		if( rmax.y < p->r.y )
			rmax.y = p->r.y;
		if( rmax.z < p->r.z )
			rmax.z = p->r.z;
	}

	*rmin0 = rmin;
	*rmax0 = rmax;
}

SystemMaxExtent(NBasicParticles,BasicParticles,nsubproc,corner,length)
int NBasicParticles;
basicparticletype *BasicParticles;
int nsubproc;
coordStruct *corner, *length;
{
	int i, self;
	int myid, numprocs;
	coordStruct rminself, rmaxself;
	coordStruct rminsrc, rmaxsrc;
	coordStruct rminall, rmaxall;
	coordStruct corn, len;

	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	MPI_Comm_rank(MPI_COMM_WORLD,&myid);

	self = myid;
		/* Assign master node for the given hyperlevel */
	MaximumExtent(NBasicParticles,BasicParticles,&rminself,&rmaxself);

	if( myid == 0 ) {
		rminall = rminself;  rmaxall = rmaxself;
		for(i=1; i<numprocs; i++) {
			RECEIVE(i, RMIN_TAG, &rminsrc, sizeof(coordStruct));
			RECEIVE(i, RMAX_TAG, &rmaxsrc, sizeof(coordStruct));

/* Find the maximum and minimum extent */

			if( rminall.x > rminsrc.x )
				rminall.x = rminsrc.x;
			if( rminall.y > rminsrc.y )
				rminall.y = rminsrc.y;
			if( rminall.z > rminsrc.z )
				rminall.z = rminsrc.z;
			if( rmaxall.x < rmaxsrc.x )
				rmaxall.x = rmaxsrc.x;
			if( rmaxall.y < rmaxsrc.y )
				rmaxall.y = rmaxsrc.y;
			if( rmaxall.z < rmaxsrc.z )
				rmaxall.z = rmaxsrc.z;
		}
		for(i=1; i<numprocs; i++) {
			SEND(i, RMIN_TAG, &rminall, sizeof(coordStruct));
			SEND(i, RMAX_TAG, &rmaxall, sizeof(coordStruct));
		}
	}
	else {
		SEND(0, RMIN_TAG, &rminself, sizeof(coordStruct));
		SEND(0, RMAX_TAG, &rmaxself, sizeof(coordStruct));
		RECEIVE(0, RMIN_TAG, &rminall, sizeof(coordStruct));
		RECEIVE(0, RMAX_TAG, &rmaxall, sizeof(coordStruct));
	}
	len.x = 1.001*(rmaxall.x - rminall.x);
	len.y = 1.001*(rmaxall.y - rminall.y);
	len.z = 1.001*(rmaxall.z - rminall.z);
	corn.x = rminall.x - .0005*len.x;
	corn.y = rminall.y - .0005*len.y;
	corn.z = rminall.z - .0005*len.z;
	*length = len;
	*corner = corn;
}
