#include<stdio.h>
#include<stdlib.h>
#include<stddef.h>
#include<sys/times.h>
#include<mpi.h>
#include "pmheader.h"
#include "Memory.h"
#define EQNBox
#include "slicemigrate.h"
#undef EQNBox

CommPair *commpair;
NSlice *nfftwslice,*ndenslice,*npotslice;
int local_z_start,local_nz;
int zstart,zheight;
float fzstart,fzheight;
int *nstridenum;
int *tmpnstridenum;
int nx,ny,nz;
int myid,numprocs;
long numpixelslice;

void DetermineProcid(){
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
}
void DetermineStrideComm(int istride){
	int i,j,k;
	int dest,src,jj,iflag;
	/* Initialize the communication table */

	for(j=0;j<numprocs;j++) commpair[j].up.flag = commpair[j].down.flag 
		= None;
	for(j=0;j<numprocs;j++){
		if(commpair[j].up.flag != None) continue;
		commpair[j].down.flag = Second;
		jj = j;
		dest = (jj + istride + numprocs) % numprocs;
		iflag = 0;
		while(commpair[dest].down.flag == None){
			commpair[jj].up.flag = commpair[dest].down.flag = 
				iflag % 2;
			commpair[jj].up.dest = dest;
			commpair[dest].down.dest = jj;
			jj = dest;
			dest = (jj + istride + numprocs) % numprocs;
			iflag ++;
		}
		if(commpair[dest].down.flag != ((iflag) %2)){
			commpair[dest].down.flag = commpair[jj].up.flag = Last;
		}
		else commpair[jj].up.flag = commpair[dest].down.flag;
		commpair[jj].up.dest = dest;
		commpair[dest].down.dest = jj;
	}
}
void determine_comm(int numprocs, CommPair *commpair){
	int istride,j,k;
	for(istride=1;istride<numprocs;istride++){
		/* Initialize the communication table */
		printf("################################\n");
		for(j=0;j<numprocs;j++) commpair[j].up.flag = commpair[j].down.flag 
			= None;
		if(myid == 0 ){
			int dest,src,jj,iflag;
			for(j=0;j<numprocs;j++){
				if(commpair[j].up.flag != None) continue;
				commpair[j].down.flag = Second;
				printf("%d ",j);
				jj = j;
				dest = (jj + istride + numprocs) % numprocs;
				iflag = 0;
				while(commpair[dest].down.flag == None){
					commpair[jj].up.flag = commpair[dest].down.flag = 
						iflag % 2;
					commpair[jj].up.dest = dest;
					commpair[dest].down.dest = jj;
					printf(" ---> %d",dest);
					jj = dest;
					dest = (jj + istride + numprocs) % numprocs;
					iflag ++;
				}
				if(commpair[dest].down.flag != ((iflag) %2)){
					commpair[dest].down.flag = commpair[jj].up.flag = Last;
					printf("Last");
				}
				else commpair[jj].up.flag = commpair[dest].down.flag;
				commpair[jj].up.dest = dest;
				commpair[dest].down.dest = jj;
				printf("\n");
			}
		}
	}
}
/* */
int nowslices[MAXPROCS][MAXPIXELS];
int afterslices[MAXPROCS][MAXPIXELS];
/* this routine checks the range of slices in current and in after mesh 
 * Multiple processors can have slice ranges that overlap each other.
 * */
void InitNslices(int nowzstart,int nowzfinal,int afterzstart,int afterzfinal){
	int i,j,k;
	MPI_Status mpistatus;
	for(i=0;i<nz;i++){
		nowslices[myid][i] = None;
		afterslices[myid][i] = None;
	}
	k = 0;
	for(i=nowzstart;i<=nowzfinal;i++){
		j = (i+nz)% nz;
		nowslices[myid][j] = k;
		k++;
	}
	k = 0;
	for(i=afterzstart;i<=afterzfinal;i++){
		j = (i+nz)% nz;
		afterslices[myid][j] = k;
		k++;
	}
	if(myid ==0){
		for(i=1;i<numprocs;i++){
			MPI_Recv(&nowslices[i][0],nz,MPI_INT,i,0,MPI_COMM_WORLD,&mpistatus);
		}
	}
	else MPI_Send(&nowslices[myid][0],nz,MPI_INT,0,0,MPI_COMM_WORLD);
	for(i=0;i<numprocs;i++){
		MPI_Bcast(&nowslices[i][0],nz,MPI_INT,0,MPI_COMM_WORLD);
	}
	if(myid ==0){
		for(i=1;i<numprocs;i++){
			MPI_Recv(&afterslices[i][0],nz,MPI_INT,i,0,MPI_COMM_WORLD,
					&mpistatus);
		}
	}
	else MPI_Send(&afterslices[myid][0],nz,MPI_INT,0,0,MPI_COMM_WORLD);
	for(i=0;i<numprocs;i++){
		MPI_Bcast(&afterslices[i][0],nz,MPI_INT,0,MPI_COMM_WORLD);
	}
	
}
/* Copy noewslices to afterslices if they are in the same processors 
 * and return meaningful nstridenum value
 * if interprocessor communication is needed.
 * */
void CheckAndCopyStride(float *nowslice,float *afterslice,
		int nowzstart,int nowzfinal,int afterzstart,int afterzfinal){
	int i,j,k,ii;
	int nowstart,afterstart;
	int otherid;
	float *now,*after;
	DetermineProcid();
	for(i=0;i<numprocs;i++) nstridenum[i] = 0;
	for(i=0;i<nz;i++){
		if(nowslices[myid][i]!= None){
			for(otherid=0;otherid<numprocs;otherid++){
				if(afterslices[otherid][i] !=  None){
					k = (otherid-myid+numprocs)%numprocs;
					nstridenum[k]++;
					if(myid==otherid) {
						/*
						now = nowslice+numpixelslice*(i-nowzstart);
						after = afterslice+numpixelslice*(i-afterzstart);
						*/
						now = nowslice+(nowslices[myid][i])*numpixelslice;
						after = afterslice+(afterslices[myid][i])*numpixelslice;
						for(ii=0;ii<numpixelslice;ii++){
							*after = *now;now++;after++;
						}
					}
				}
			}
		}
	}
	(void) MPI_Reduce(nstridenum,tmpnstridenum,numprocs,MPI_INT,MPI_SUM,
					  0,MPI_COMM_WORLD);
	if(myid==0) {
		for(i=0;i<numprocs;i++) {
			nstridenum[i] = tmpnstridenum[i];
		}
	}
	MPI_Bcast(nstridenum,numprocs,MPI_INT,0,MPI_COMM_WORLD);
}
void SliceSend(int dest, float *den){
	int i,j,k;
	int nowid,afterid;
	for(i=0;i<nz;i++){
		if((nowid=nowslices[myid][i])!=None &&
				(afterid=afterslices[dest][i])!=None){
			MPI_Send(&afterid,1,MPI_INT,dest,0,MPI_COMM_WORLD);
			MPI_Send(den+nowid*numpixelslice,numpixelslice,MPI_FLOAT,dest,0,
					MPI_COMM_WORLD);
		}
	}
	afterid = CLOSE;
	MPI_Send(&afterid,1,MPI_INT,dest,0,MPI_COMM_WORLD);
}
void SliceRecvAdd(int src, float *den, float *tmpslice){
	int ii;
	int nowid,afterid;
	MPI_Status status;
	MPI_Recv(&afterid,1,MPI_INT,src,0,MPI_COMM_WORLD,&status);
	while(afterid!=CLOSE){
		MPI_Recv(tmpslice,numpixelslice,MPI_FLOAT,src,0,
				MPI_COMM_WORLD,&status);
		for(ii=0;ii<numpixelslice;ii++){
			if(tmpslice[ii] < 0.) fprintf(stderr,"Error in slicerecvadd\n");
		}
		for(ii=0;ii<numpixelslice;ii++){
			*(den+afterid*numpixelslice+ii) += tmpslice[ii];
		}
		MPI_Recv(&afterid,1,MPI_INT,src,0,MPI_COMM_WORLD,&status);
	}
}
void SliceRecv(int src, float *den){
	int i,j,k;
	int nowid,afterid;
	MPI_Status status;
	MPI_Recv(&afterid,1,MPI_INT,src,0,MPI_COMM_WORLD,&status);
	while(afterid!=CLOSE){
		MPI_Recv(den+afterid*numpixelslice,numpixelslice,MPI_FLOAT,src,0,
				MPI_COMM_WORLD,&status);
		MPI_Recv(&afterid,1,MPI_INT,src,0,MPI_COMM_WORLD,&status);
	}
}
void RearrangePot(int Nx,int Ny, int Nz, int zwidth,float *den){
	int i,j,k;
	int numpixelslice,numtmp;
	float *tmpden,*a,*b;

	numpixelslice = Ny*(2*(Nx/2+1));
	tmpden = (float *) Malloc(sizeof(float)*3*numpixelslice,PPTR(tmpden));
	a = tmpden;
	b = den;

	for(i=0;i<3*numpixelslice;i++){
		*a = *b; a++;b++;
	}
	numtmp = (zwidth-3)*numpixelslice;
	a = den;
	b = den+3*numpixelslice;
	for(i=0;i<numtmp;i++){
		*a = *b ; a++;b++;
	}
	b = tmpden;
	for(i=0;i<3*numpixelslice;i++){
		*a = *b; a++;b++;
	}
	Free(tmpden);
}
void tsc_fftw_mesh(float *den, int Zstart,int Zheight,
	float *fftslice, int Local_z_start, int Local_nz, int Nx,int Ny,int Nz){
	int i,j,k,nzstart,nzheight;
	int dest,src;
	int nowzstart,nowzfinal,afterzstart,afterzfinal;
	float *tmpslice;
	/* From argument to Local Global Viriables */
	local_z_start=Local_z_start; local_nz=Local_nz; zstart=Zstart; 
	zheight=Zheight; 
	nowzstart = zstart -1; /* -1 is due to the buffer slice */
	nowzfinal = zstart + zheight-1 +2; /* +2 is due to the buffer slice */
	afterzstart = local_z_start;
	afterzfinal = local_z_start + local_nz-1;
	nx = Nx; ny = Ny; nz = Nz;
	numpixelslice = ny*(2*(nx/2+1));
	DetermineProcid();


	nstridenum = (int *) Malloc(sizeof(int)*numprocs,PPTR(nstridenum));
	tmpnstridenum = (int *) Malloc(sizeof(int)*numprocs,PPTR(tmpnstridenum));
	commpair = (CommPair *)Malloc(sizeof(CommPair)*numprocs,PPTR(commpair));

	InitNslices(nowzstart,nowzfinal,afterzstart,afterzfinal);
	CheckAndCopyStride(den,fftslice,nowzstart,nowzfinal,afterzstart,
			afterzfinal);
	tmpslice = (float *) Malloc(sizeof(float)*numpixelslice,PPTR(tmpslice));
	fflush(stdout);fflush(stderr);
	MPI_Barrier(MPI_COMM_WORLD);

	for(i=1;i<numprocs;i++){
		if(nstridenum[i] > 0){
			DetermineStrideComm(i);
			if(myid==0) printf("Stride #=%d\n",i);fflush(stdout);
			dest = commpair[myid].up.dest;
			src = commpair[myid].down.dest;
			if(commpair[myid].up.flag == First){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == First){
				SliceRecvAdd(src,fftslice,tmpslice);
			}
			if(commpair[myid].up.flag == Second){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == Second){
				SliceRecvAdd(src,fftslice,tmpslice);
			}
			if(commpair[myid].up.flag == Last){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == Last){
				SliceRecvAdd(src,fftslice,tmpslice);
			}
		}
	}
	Free(tmpslice);
	Free(commpair);
	Free(tmpnstridenum);
	Free(nstridenum);
	for(i=0;i<2*(nx/2+1)*ny*local_nz;i++) fftslice[i] = fftslice[i]-1.;
}
void den2fft_mesh(float *den, int Zstart,int Zheight,
	float *fftslice, int Local_z_start, int Local_nz, int Nx,int Ny,int Nz){
	int i,j,k,nzstart,nzheight;
	int dest,src;
	int nowzstart,nowzfinal,afterzstart,afterzfinal;
	/* From argument to Local Global Viriables */
	local_z_start=Local_z_start; local_nz=Local_nz; zstart=Zstart; 
	zheight=Zheight; 
	nowzstart = zstart;
	nowzfinal = zstart + zheight-1;
	afterzstart = local_z_start;
	afterzfinal = local_z_start + local_nz-1;
	nx = Nx; ny = Ny; nz = Nz;
	numpixelslice = ny*(2*(nx/2+1));
	DetermineProcid();

	nstridenum = (int *) Malloc(sizeof(int)*numprocs,PPTR(nstridenum));
	tmpnstridenum = (int *) Malloc(sizeof(int)*numprocs,PPTR(tmpnstridenum));
	commpair = (CommPair *)Malloc(sizeof(CommPair)*numprocs,PPTR(commpair));

	InitNslices(nowzstart,nowzfinal,afterzstart,afterzfinal);
	CheckAndCopyStride(den,fftslice,nowzstart,nowzfinal,afterzstart,
			afterzfinal);

	for(i=1;i<numprocs;i++){
		if(nstridenum[i] > 0){
			DetermineStrideComm(i);
			if(myid==0) printf("Stride #=%d\n",i);fflush(stdout);
			dest = commpair[myid].up.dest;
			src = commpair[myid].down.dest;
			if(commpair[myid].up.flag == First){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == First){
				SliceRecv(src,fftslice);
			}
			if(commpair[myid].up.flag == Second){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == Second){
				SliceRecv(src,fftslice);
			}
			if(commpair[myid].up.flag == Last){
				SliceSend(dest,den);
			}
			else if(commpair[myid].down.flag == Last){
				SliceRecv(src,fftslice);
			}
		}
	}
	Free(commpair);
	Free(tmpnstridenum);
	Free(nstridenum);
}
#define NRANSI
#define SWAP(a,b) itemp=(a);(a)=(b);(b)=itemp;
#define M 7
#define NSTACK 50
#define NSTACKp1 51
#define NR_END 1

void indexx(unsigned long n, basicparticletype *p) {
	unsigned long i,indxt,ir=n,itemp,j,k,l=1;
	int jstack=0;
	int istack[NSTACKp1];
	float a;

	for (j=1;j<=n;j++) p[j].u.sort=j;
	for (;;) {
		if (ir-l < M) {
			for (j=l+1;j<=ir;j++) {
				indxt=p[j].u.sort;
				a=p[indxt].z;
				for (i=j-1;i>=1;i--) {
					if (p[p[i].u.sort].z <= a) break;
					p[i+1].u.sort=p[i].u.sort;
				}
				p[i+1].u.sort=indxt;
			}
			if (jstack == 0) break;
			ir=istack[jstack--];
			l=istack[jstack--];
		} else {
			k=(l+ir) >> 1;
			SWAP(p[k].u.sort,p[l+1].u.sort);
			if (p[p[l+1].u.sort].z > p[p[ir].u.sort].z) {
				SWAP(p[l+1].u.sort,p[ir].u.sort)
			}
			if (p[p[l].u.sort].z > p[p[ir].u.sort].z) {
				SWAP(p[l].u.sort,p[ir].u.sort)
			}
			if (p[p[l+1].u.sort].z > p[p[l].u.sort].z) {
				SWAP(p[l+1].u.sort,p[l].u.sort)
			}
			i=l+1;
			j=ir;
			indxt=p[l].u.sort;
			a=p[indxt].z;
			for (;;) {
				do i++; while (p[p[i].u.sort].z < a);
				do j--; while (p[p[j].u.sort].z > a);
				if (j < i) break;
				SWAP(p[i].u.sort,p[j].u.sort)
			}
			p[l].u.sort=p[j].u.sort;
			p[j].u.sort=indxt;
			jstack += 2;
			if (jstack > NSTACK) fprintf(stderr,"NSTACK too small in indexx.");
			if (ir-i+1 >= j-l) {
				istack[jstack]=ir;
				istack[jstack-1]=i;
				ir=j-1;
			} else {
				istack[jstack]=j-1;
				istack[jstack-1]=l;
				l=i;
			}
		}
	}
}
#undef NR_END
#undef M
#undef NSTACK
#undef SWAP
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
#define TIMER_START(A) cputime0[A] = gettime();
#define TIMER_STOP(A)  cputime1[A] = gettime();
#define ELAPSED_TIME(A) (cputime1[A] - cputime0[A])

void EQNZBox(int np,basicparticletype *p, ZBox *zbox, float zfloor,
		float zceil){
	int i,j,k;
	float cputime0[10],cputime1[10];
	float stime,ftime;
	indextype *numparticle;
	indextype *tmpnum;
	indextype totaln,localn;
	indextype mynstart,mynfinal;
	indextype ntmp,ntmp2;
	ZBox *tmpzbox,aaa;

	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
	numparticle = (indextype *) Malloc(sizeof(indextype)*numprocs,
			PPTR(numparticle));
	tmpnum = (indextype *) Malloc(sizeof(indextype)*numprocs,PPTR(tmpnum));
	for(i=0;i<numprocs;i++) tmpnum[i] = 0;
	tmpnum[myid] = np;
	MPI_Reduce(tmpnum,numparticle,numprocs,MPI_INDEX,MPI_SUM,0,
				MPI_COMM_WORLD);
	MPI_Bcast(numparticle,numprocs*sizeof(indextype),MPI_BYTE,0,MPI_COMM_WORLD);
	Free(tmpnum);

	totaln = 0;
	for(i=0;i<numprocs;i++) totaln += numparticle[i];
	localn = totaln / (indextype) numprocs;
	mynstart = 0;
	for(i=0;i<myid;i++) mynstart += numparticle[i];
	mynfinal = mynstart+numparticle[myid];

	Free(numparticle);

	for(i=0;i<numprocs;i++) 
		zbox[i].zstart = zbox[i].zfinal = zbox[i].zwidth = 0.;
	MPI_Barrier(MPI_COMM_WORLD);
	TIMER_START(9);
	zsortparticles(np,p);
	TIMER_STOP(9);
	MPI_Barrier(MPI_COMM_WORLD);
	if(myid==0) fprintf(stdout,"The sorting time is %f\n",ELAPSED_TIME(99));
	for(i=0;i<numprocs;i++) {
		ntmp = i*localn;
		if(ntmp >=mynstart && ntmp < mynfinal){
			ntmp2 = ntmp-mynstart;
			zbox[i].zstart = FindZofParticle(ntmp2,p);
		}
	}
	{
		Define_ZBox_MPI_Type;
		MPI_Type_struct(NELZBOX,blocklens,indices,old_types,&MPI_ZBox_type);
		tmpzbox = (ZBox *)Malloc(sizeof(ZBox)*numprocs,PPTR(tmpzbox));
		for(i=0;i<numprocs;i++) tmpzbox[i] = zbox[i];
		MPI_Reduce(tmpzbox,zbox,numprocs,MPI_ZBox_type,myop,0,
				MPI_COMM_WORLD);
		Free(tmpzbox);
		if(myid==0) {
			zbox[0].zstart = zfloor;
			zbox[numprocs-1].zfinal = zceil;
			for(i=0;i<numprocs-1;i++) zbox[i].zfinal = zbox[i+1].zstart;
		}
		MPI_Bcast(zbox,numprocs,MPI_ZBox_type,0,MPI_COMM_WORLD);
		Delete_ZBox_MPI_Op;
	}
	return ;
}
#undef TIMER_START
#undef TIMER_STOP
#undef ELAPSED_TIME
