typedef struct coordStruct {
	float x, y, z;
} coordStruct;

typedef struct nodeStruct {
	int type;
	int cellnum;
	struct nodeStruct *sibling;         /* sibling node (also next node) */
	struct nodeStruct *next;         /* next node (also next node) */
} nodeStruct;

typedef struct particleStruct {      /* properties associated to each part */
  int type;
  int cellnum;
  struct nodeStruct *sibling;         /* sibling node (also next node) */
  struct nodeStruct *next;         /* next node (also next node) */
  float mass;                         /* mass     */
  float epssq;                        /* plummer softening */
  coordStruct r;                      /* location */
  coordStruct v;                      /* location */
  coordStruct a;
  float phi;
  int mono;
  int quad;
  float work;
  struct particleStruct *nextinbin;
  int idnum;
  int visitor;
} particleStruct;

typedef struct cellStruct {
  int type;                           /* the type (ie content) of the cell */
  int cellnum;
  struct nodeStruct *sibling;         /* sibling node (also next node) */
  struct nodeStruct *next;            /* next node (also next node) */
  float mass;                         /* the cell mass */
  float epssq;                        /* Plummer softening */
  coordStruct r;                      /* the coord of its center */
  float qxx, qyy, qzz, qxy, qxz, qyz, mom; /* quadrupole tensor components */
  int nchildren;                     /* number of children */
  int nbodies;                        /* number of particles in cell */
  float cellsq;                       /* width of the cell squared */
  float radius;                        /* "radius" of the cell*/
  coordStruct corner;                 /* the lower corner */
  coordStruct length;                 /* the box x,y,z lengths */
  int leaf;                           /* leaf = 1 if tree is pruned here */
  int secondleaf;
} cellStruct;
