/*
 *  ڵ  X0,Y0,Z0  ġ ڰ ùķ̼ ڽ 
 * ùķ̼ ڵ     Ÿ.
 *   comoving space  ùķ̼ǿ  Ÿ ´.
 *  theta, phi    1и鿡  ϴ.
 *  2,3,4 и鿡 ϰ ҷ, min,max   
 * ٲپ Ѵ. ׸  κп ش ڸ ã  phi  
 * ϴµ,
 * ⿡ ׳ 1,4и̶  ߴ. 
 * wflag   2 ǥؾ Ѵ.
 * 09/08/2002  
 * cc -o survey survey.c Memory2.c -lm
 */
#include<stdio.h>
#include<stdlib.h>
#include <math.h>
#include "Memory.h"
#include "pmheader.h"
/*
#include "pm_extern.h"
*/
#include "survey.h"
#define MIN(A,B) ((A) <(B) ? (A):(B))
double Theta,Phi,DTheta,DPhi;
char surveyfilename[100];
int *freework;
enum boolean { NO = 00,YES = 01};
typedef struct Spherical{
	double r,theta,phi;
} Spherical;
unsigned int setbits(unsigned int x,int p) {
    unsigned int  b;
	b = x|(~((~0)<<1) << (p-1));
	return b;
}
InBox *box;
float *mpx,*mpy,*mpz;
double r1, r2;
double theta1,phi1,theta2,phi2;
int sortindx(const void *a,const void *b){
	double *aa,*bb;
	aa = (double *)a;
	bb = (double *)b;
	if(*aa < *bb) return -1;
	else if(*aa > *bb) return +1;
	else return 0;
}
void Pixel2Sph(float xpixel,float ypixel, float zpixel,
		double *r, double *theta,double *phi){
	double x,y,z;
	x = xpixel-X0;
	y = ypixel-Y0;
	z = zpixel-Z0;
	*r = sqrt(x*x+y*y+z*z);
	*theta = acos(z/sqrt(x*x+y*y));
	if(y>=0) *phi = acos(x/sqrt(x*x+y*y));
	else *phi = 2.L*pi-acos(x/sqrt(x*x+y*y));
	return;
}
float omega0,H,lambda0;
float func1(float red){
    return 2997.92L/sqrt((1.+red)*(1.+red)*(1.+red)*omega0
             +(1.+red)*(1.+red)*(1.-omega0-lambda0) +lambda0);
}
float qsimp(float (*)(float),float,float);
float trapzd(float (*)(float), float , float , int );
void a2comovingpixel(double *R, double *dR1, double *dR2,int nx, 
		float amax,float a, float astep1,float astep2,
		float omep,float omeplam,float size, float h){
	float initz = 0;
	float shellwidth1,shellwidth2;
	float redshift = amax/a - 1.L;
	shellwidth1 = amax/(a+astep2*0.5L)-1.L;
	shellwidth2 = amax/(a-astep1*0.5L)-1.L;
	if(omep == 1.0) {
		*R = 2.L*2997.92L * (1.L-1.L/sqrt(1.L+redshift));
		*dR1 = 2.L*2997.92L*(1.L-1.L/sqrt(1.L+shellwidth1));
		*dR2 = 2.L*2997.92L*(1.L-1.L/sqrt(1.L+shellwidth2));
	}
	else {
		omega0 = omep;
		lambda0 = omeplam;
		H = h;
		*R = qsimp(func1,initz,redshift);
		*dR1 = qsimp(func1,initz,shellwidth1);
		*dR2 = qsimp(func1,initz,shellwidth2);
	}
	*R = *R/size*nx;
	*dR1 = *dR1/size*nx;
	*dR2 = *dR2/size*nx;
	*dR1 = *R - *dR1;
	*dR2 = *dR2 - *R;
}
void insert(InBox *box,int *nbox,double tmpx,double tmpy,double tmpz,
		int nx,int ny,int nz){
	int i;
	int ntmpx,ntmpy,ntmpz;
	ntmpx = tmpx/nx; ntmpy = tmpy/ny; ntmpz = tmpz/nz;
	for(i=0;i<*nbox;i++){
		if(box[i].nx == ntmpx && box[i].ny == ntmpy && box[i].nz == ntmpz) 
			return ;
	}
	box[*nbox].nx = ntmpx;
	box[*nbox].ny = ntmpy;
	box[*nbox].nz = ntmpz;
	(*nbox)++;
	/*
	printf("%d %d %d %d\n",*nbox,ntmpx,ntmpy,ntmpz);
	*/
}

int SurveySub(pmparticletype *particles,int np,
		int nx,int ny,int nz,
		float amax, float a, float da1,float da2,float boxsize,
		float omep,float omeplam,float h){
	double dr,dtheta,dphi;
	double r,dr1,dr2;
	double tmpr,tmptheta,tmpphi;
	double *rs,*thetas,*phis;
	size_t nrs,nthetas,nphis;
	int ntmp;
	int ntheta,nr,nphi;
	int nbox;
	int i,j,k;
	int ii,jj,kk;
	double tmpx,tmpy,tmpz;
	int ntmpx,ntmpy,ntmpz;
	/* */
	/* */
	a2comovingpixel(&r,&dr1,&dr2,nx,amax,a,da1,da2,omep,omeplam,boxsize,h);
	r1 = (r-dr1);
	r2 = (r+dr2);
	/* */
	theta1 = Theta; theta2 = Theta+DTheta;
	phi1 = Phi; phi2 = Phi+DPhi;
	fprintf(stderr,"rmin= %g rmax=%g in survey\n",r1*sin(theta1)/nx,r2*sin(theta2)/nx);
	/* */
	/*
	dr = 2.L;
	dtheta = 2.L/r1;
	dphi = 2.L/r1/sin(theta1);
	nr = (r2-r1)/dr + 1;
	ntheta = DTheta/dtheta + 1;
	nphi = DPhi/dphi + 1;
	*/
	nbox = 0;
	rs = (double *)Malloc(sizeof(double)*10000L,PPTR(rs));
	thetas = (double *)Malloc(sizeof(double)*10000L,PPTR(thetas));
	phis = (double *)Malloc(sizeof(double)*10000L,PPTR(phis));
	nphis = 0;
	phis[nphis++] = phi1;
	phis[nphis++] = phi2;
	{
		int max,min;
		max = (r2*sin(theta1)*cos(phi1)+X0)/nx+1;
		min = (r2*sin(theta1)*cos(phi2)+X0)/nx-1;
		for(i=min;i<=max;i++){
			tmpphi = acos((nx*i-X0)/(r2*sin(theta1)));
			tmpy = r2*sin(theta1)*sin(tmpphi);
			if(tmpy<0.L) tmpphi = 2.L*pi-tmpphi;
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}

		max = (r2*sin(theta1)*sin(phi2)+Y0)/ny+1;
		min = (r2*sin(theta1)*sin(phi1)+Y0)/ny-1;
		for(i=min;i<=max;i++){
			tmpphi = asin((ny*i-Y0)/(r2*sin(theta1)));
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}
	}
	qsort(phis,nphis,sizeof(double),sortindx);
	for(k=0;k<nphis;k++){
		/*
		if(k==0 || k == nphis-1) tmpphi = phis[k];
		else tmpphi = (phis[k]+phis[k+1])*0.5;
		*/
		for(kk=0;kk<=100;kk++){
			int kmax;
			kmax = MIN(k+1,nphis-1);
			tmpphi = kk*(phis[kmax]-phis[k])/100.+phis[k];
			nthetas = 0;
			thetas[nthetas++] = theta1;
			thetas[nthetas++] = theta2;
			{
				int max,min;
				min = (r2*sin(theta1)*cos(tmpphi)+X0)/nx-1;
				max = (r2*sin(theta2)*cos(tmpphi)+X0)/nx+1;
				for(i=min;i<=max;i++){
					tmptheta = asin((nx*i-X0)/(r2*cos(tmpphi)));
					if(tmptheta >= theta1 && tmptheta <= theta2) 
						thetas[nthetas++] = tmptheta;
				}
				min = (r2*sin(theta1)*sin(tmpphi)+Y0)/ny-1;
				max = (r2*sin(theta2)*sin(tmpphi)+Y0)/ny+1;
				for(i=min;i<=max;i++){
					tmptheta = asin((ny*i-Y0)/(r2*sin(tmpphi)));
					if(tmptheta >= theta1 && tmptheta <= theta2) 
						thetas[nthetas++] = tmptheta;
				}
				min = (r2*cos(theta2)+Z0)/nz-1;
				max = (r2*cos(theta1)+Z0)/nz+1;
				for(i=min;i<=max;i++){
					tmptheta = acos((nz*i-Z0)/r2);
					if(tmptheta >= theta1 && tmptheta <= theta2) 
						thetas[nthetas++] = tmptheta;
				}
			}
			qsort(thetas,nthetas,sizeof(double),sortindx);
			for(j=0;j<nthetas;j++){
				for(jj=0;jj<=5;jj++){
					int maxj;
					maxj = MIN(j+1,nthetas-1);
					tmptheta = jj*(thetas[maxj]-thetas[j])/100.+thetas[j];
					nrs = 0;
					rs[nrs++] = r2;
					rs[nrs++] = r1;
					{
						int max,min;
						max = (r2*sin(tmptheta)*cos(tmpphi)+X0)/nx+1;
						min = (r1*sin(tmptheta)*cos(tmpphi)+X0)/nx-1;
						for(i=min;i<=max;i++){
							tmpr = (nx*i-X0)/(sin(tmptheta)*cos(tmpphi));
							if(tmpr >= r1 && tmpr <= r2)
								rs[nrs++] = tmpr;
						}
						max = (r2*sin(tmptheta)*sin(tmpphi)+Y0)/ny+1;
						min = (r1*sin(tmptheta)*sin(tmpphi)+Y0)/ny-1;
						for(i=min;i<=max;i++){
							tmpr = (ny*i-Y0)/(sin(tmptheta)*sin(tmpphi));
							if(tmpr >=r1 && tmpr <= r2) 
								rs[nrs++] = tmpr;
						}
						max = (r2*cos(tmptheta)+Z0)/nz+1;
						min = (r1*cos(tmptheta)+Z0)/nz-1;
						for(i=min;i<=max;i++){
							tmpr = (nz*i-Z0)/cos(tmptheta);
							if(tmpr >=r1 && tmpr <= r2) 
								rs[nrs++] = tmpr;
						}
					}
					qsort(rs,nrs,sizeof(double),sortindx);
					for(i=0;i<nrs;i++){
						tmpx = rs[i]*sin(tmptheta)*cos(tmpphi)+X0;
						tmpy = rs[i]*sin(tmptheta)*sin(tmpphi)+Y0;
						tmpz = rs[i]*cos(tmptheta)+Z0;
						insert(box,&nbox,tmpx,tmpy,tmpz,nx,ny,nz);
					}
				}
			}
		}
	}
	/* r = r1 theta = theta1*/
	nphis = 0;
	phis[nphis++] = phi1;
	phis[nphis++] = phi2;
	{
		int max,min;
		max = (r1*sin(theta1)*cos(phi1)+X0)/nx+1;
		min = (r1*sin(theta1)*cos(phi2)+X0)/nx-1;
		for(i=min;i<=max;i++){
			tmpphi = acos((nx*i-X0)/(r1*sin(theta1)));
			tmpy = r1*sin(theta1)*sin(tmpphi);
			if(tmpy<0.L) tmpphi = 2.L*pi-tmpphi;
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}

		max = (r1*sin(theta1)*sin(phi2)+Y0)/ny+1;
		min = (r1*sin(theta1)*sin(phi1)+Y0)/ny-1;
		for(i=min;i<=max;i++){
			tmpphi = asin((ny*i-Y0)/(r1*sin(theta1)));
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}
	}
	qsort(phis,nphis,sizeof(double),sortindx);
	for(k=0;k<nphis;k++){
		tmpphi = phis[k];
		nthetas = 0;
		thetas[nthetas++] = theta1;
		thetas[nthetas++] = theta2;
		{
			int max,min;
			min = (r1*sin(theta1)*cos(tmpphi)+X0)/nx-1;
			max = (r1*sin(theta2)*cos(tmpphi)+X0)/nx+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((nx*i-X0)/(r1*cos(tmpphi)));
				if(tmptheta >= theta1 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r1*sin(theta1)*sin(tmpphi)+Y0)/ny-1;
			max = (r1*sin(theta2)*sin(tmpphi)+Y0)/ny+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((ny*i-Y0)/(r1*sin(tmpphi)));
				if(tmptheta >= theta1 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r1*cos(theta2)+Z0)/nz-1;
			max = (r1*cos(theta1)+Z0)/nz+1;
			for(i=min;i<=max;i++){
				tmptheta = acos((nz*i-Z0)/r1);
				if((tmptheta >= theta1 && tmptheta <= theta2)) 
					thetas[nthetas++] = tmptheta;
			}
		}
		for(j=0;j<nthetas;j++){
			tmptheta = thetas[j];
			tmpx = r1*sin(tmptheta)*cos(tmpphi)+X0;
			tmpy = r1*sin(tmptheta)*sin(tmpphi)+Y0;
			tmpz = r1*cos(tmptheta)+Z0;
			insert(box,&nbox,tmpx,tmpy,tmpz,nx,ny,nz);
		}
	}
	/* r = r2, theta = theta2 */
	nphis = 0;
	phis[nphis++] = phi1;
	phis[nphis++] = phi2;
	{
		int max,min;
		max = (r2*sin(theta2)*cos(phi1)+X0)/nx+1;
		min = (r2*sin(theta2)*cos(phi2)+X0)/nx-1;
		for(i=min;i<=max;i++){
			tmpphi = acos((nx*i-X0)/(r2*sin(theta2)));
			tmpy = r2*sin(theta2)*sin(tmpphi);
			if(tmpy<0.L) tmpphi = 2.L*pi-tmpphi;
			if((tmpphi>= phi1 && tmpphi<= phi2)) 
				phis[nphis++] = tmpphi;
		}

		max = (r2*sin(theta2)*sin(phi2)+Y0)/ny+1;
		min = (r2*sin(theta2)*sin(phi1)+Y0)/ny-1;
		for(i=min;i<=max;i++){
			tmpphi = asin((ny*i-Y0)/(r2*sin(theta2)));
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}
	}
	qsort(phis,nphis,sizeof(double),sortindx);
	for(k=0;k<nphis;k++){
		tmpphi = phis[k];
		nthetas = 0;
		thetas[nthetas++] = theta2;
		thetas[nthetas++] = theta2;
		{
			int max,min;
			min = (r2*sin(theta2)*cos(tmpphi)+X0)/nx-1;
			max = (r2*sin(theta2)*cos(tmpphi)+X0)/nx+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((nx*i-X0)/(r2*cos(tmpphi)));
				if(tmptheta >= theta2 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r2*sin(theta2)*sin(tmpphi)+Y0)/ny-1;
			max = (r2*sin(theta2)*sin(tmpphi)+Y0)/ny+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((ny*i-Y0)/(r2*sin(tmpphi)));
				if(tmptheta >= theta2 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r2*cos(theta2)+Z0)/nz-1;
			max = (r2*cos(theta2)+Z0)/nz+1;
			for(i=min;i<=max;i++){
				tmptheta = acos((nz*i-Z0)/r2);
				if((tmptheta >= theta2 && tmptheta <= theta2)) 
					thetas[nthetas++] = tmptheta;
			}
		}
		for(j=0;j<nthetas;j++){
			tmptheta = thetas[j];
			tmpx = r2*sin(tmptheta)*cos(tmpphi)+X0;
			tmpy = r2*sin(tmptheta)*sin(tmpphi)+Y0;
			tmpz = r2*cos(tmptheta)+Z0;
			insert(box,&nbox,tmpx,tmpy,tmpz,nx,ny,nz);
		}
	}
	/* r = r1, theta = theta2 */
	nphis = 0;
	phis[nphis++] = phi1;
	phis[nphis++] = phi2;
	{
		int max,min;
		max = (r1*sin(theta2)*cos(phi1)+X0)/nx+1;
		min = (r1*sin(theta2)*cos(phi2)+X0)/nx-1;
		for(i=min;i<=max;i++){
			tmpphi = acos((nx*i-X0)/(r1*sin(theta2)));
			tmpy = r1*sin(theta2)*sin(tmpphi);
			if(tmpy<0.L) tmpphi = 2.L*pi-tmpphi;
			if((tmpphi>= phi1 && tmpphi<= phi2)) 
				phis[nphis++] = tmpphi;
		}

		max = (r1*sin(theta2)*sin(phi2)+Y0)/ny+1;
		min = (r1*sin(theta2)*sin(phi1)+Y0)/ny-1;
		for(i=min;i<=max;i++){
			tmpphi = asin((ny*i-Y0)/(r1*sin(theta2)));
			if(tmpphi>= phi1 && tmpphi<= phi2) phis[nphis++] = tmpphi;
		}
	}
	qsort(phis,nphis,sizeof(double),sortindx);
	for(k=0;k<nphis;k++){
		tmpphi = phis[k];
		nthetas = 0;
		thetas[nthetas++] = theta2;
		thetas[nthetas++] = theta2;
		{
			int max,min;
			min = (r1*sin(theta2)*cos(tmpphi)+X0)/nx-1;
			max = (r1*sin(theta2)*cos(tmpphi)+X0)/nx+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((nx*i-X0)/(r1*cos(tmpphi)));
				if(tmptheta >= theta2 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r1*sin(theta2)*sin(tmpphi)+Y0)/ny-1;
			max = (r1*sin(theta2)*sin(tmpphi)+Y0)/ny+1;
			for(i=min;i<=max;i++){
				tmptheta = asin((ny*i-Y0)/(r1*sin(tmpphi)));
				if(tmptheta >= theta2 && tmptheta <= theta2) 
					thetas[nthetas++] = tmptheta;
			}
			min = (r1*cos(theta2)+Z0)/nz-1;
			max = (r1*cos(theta2)+Z0)/nz+1;
			for(i=min;i<=max;i++){
				tmptheta = acos((nz*i-Z0)/r1);
				if((tmptheta >= theta2 && tmptheta <= theta2)) 
					thetas[nthetas++] = tmptheta;
			}
		}
		for(j=0;j<nthetas;j++){
			tmptheta = thetas[j];
			tmpx = r1*sin(tmptheta)*cos(tmpphi)+X0;
			tmpy = r1*sin(tmptheta)*sin(tmpphi)+Y0;
			tmpz = r1*cos(tmptheta)+Z0;
			insert(box,&nbox,tmpx,tmpy,tmpz,nx,ny,nz);
		}
	}
	/* */
	Free(phis);Free(thetas);Free(rs);
	/*
	fprintf(stdout,"in survey, nbox is %d\n",nbox);
	{
		float xp,yp,zp;
		float dist2;
		float rmin2,rmax2;
		float invx2y2;
		int npsurvey;
		mpx = (float *)Malloc(sizeof(float)*nbox,PPTR(mpx));
		mpy = (float *)Malloc(sizeof(float)*nbox,PPTR(mpy));
		mpz = (float *)Malloc(sizeof(float)*nbox,PPTR(mpz));
		for(i=0;i<nbox;i++){
			mpx[i] = box[i].nx*nx-X0; 
			mpy[i] = box[i].ny*ny-Y0; 
			mpz[i] = box[i].nz*nz-Z0;
		}
		for(i=0;i<np;i++)freework[i] = -1;
		rmin2 = r1*r1;
		rmax2 = r2*r2;
		npsurvey = 0;
		for(i=0;i<np;i++){
			for(j=0;j<nbox;j++){
				xp = particles[i].x+mpx[j];
				yp = particles[i].y+mpy[j];
				zp = particles[i].z+mpz[j];
				dist2 = xp*xp+yp*yp+zp*zp;
				if(dist2 >= rmin2 && dist2 < rmax2) {
					invx2y2 = 1./sqrt(dist2-zp*zp);
					tmptheta = asin(zp*invx2y2);
					if(tmptheta >= theta1 && tmptheta < theta2 ){
						tmpphi = acos(xp*invx2y2);
						if(tmpphi >=phi1 && tmpphi < phi2){
							freework[i] = 1;
							continue;
						}
					}
				}
			}
		}
		Free(mpz);Free(mpy);Free(mpx);
	}
	*/
	return nbox;
}
int surveywrite(pmparticletype *,int , InBox *,int ,
       int ,int ,int ,double ,double ,int ,float ,float ,
       float , int ,int ,int *);
int semi_surveywrite(pmparticletype *,int , float,float,float,InBox *,int ,
       int ,int ,int ,double ,double ,int ,float ,float ,
       float , int ,int ,int *,float , double);
int survey(pmparticletype *particles,int np,int nx,int ny,int nz,
		int mstep, float amax, float a, float astep,float nextastep,
		float boxsize,
		float omep,float omeplam,float hubble,int myrank,int nrank,int ntype){
	float redshift;
	int nbox;
	if(ntype == 0){
		Theta = 65.L*pi/180.L;
		Phi = 5.L*pi/180.L;
		DTheta = 0.1875*pi/180.L;
		DPhi = 80.L*pi/180.L;
		sprintf(surveyfilename,"survey%.2d",ntype);
	}
	else if(ntype == 1){
		Theta = 75.L*pi/180.L;
		Phi = 44.L*pi/180.L;
		DTheta = 2.*pi/180.L;
		DPhi = 2.*pi/180.L;
		sprintf(surveyfilename,"survey%.2d",ntype);
	}
	box = (InBox *)Malloc(sizeof(InBox)*100000L,PPTR(box));
	freework = (int *)Malloc(sizeof(int)*np,PPTR(box));
	nbox = SurveySub(particles,np, nx , ny, nz, amax,a,astep, nextastep, 
			boxsize, omep, omeplam, hubble);
	(void ) surveywrite(particles,np,box,nbox,nx,ny,nz,
						r1,r2,mstep,amax,a,boxsize,myrank,nrank,freework);
	Free(freework);
	Free(box);
	return 0;
}
int semi_simplesurvey(pmparticletype *particles,int np,int nx,int ny,int nz,
		int mstep, float amax, float a, float astep,float nextastep,
		float boxsize,
		float omep,float omeplam,float hubble,int myrank,int nrank,int ntype, 
		float maxd){
	float redshift;
	int nbox;
	float x0,y0,z0;
	double rot,r,dr1,dr2;
	box = (InBox *)Malloc(sizeof(InBox)*6,PPTR(box));
	x0 = 0.; y0 = ny*0.5; z0 = 0.;
	z0 = 0.-(float)ntype*(float)nz/4.L;
	rot = atan(7.L/8.L/3.L);/* Rotation on the y axis */
	a2comovingpixel(&r,&dr1,&dr2,nx,amax,a,astep,nextastep,omep,omeplam,
			boxsize,hubble);
	r1 = (r-dr1);
	r2 = (r+dr2);
	sprintf(surveyfilename,"semi_survey%.2d",ntype);
	if(myrank == 0) {
		printf("Entering SEMISURVEY mode\n");
		printf("OBSERVER at X=%g Y=%g Z=%g\n",x0,y0,z0);
		printf("saving data to %s from z_min=%g to z_max=%g\n",surveyfilename,r1,r2);
		printf("saving buffer data with width %g\n",maxd);
		fflush(stdout);
	}
	Theta = pi*0.5L;
	Phi = 0.;
	DTheta = 0.0379564452L;
	DPhi = 0.158655262L;
	if(ntype == 0){
		nbox = 3;
		box[0].nx = box[0].ny =box[0].nz=0;
		box[1].nx = 1;box[1].ny =box[1].nz=0;
		box[2].nx = 2;box[2].ny =box[2].nz=0;
	}
	else {
		nbox = 6;
		box[0].nx = box[0].ny =box[0].nz=0;
		box[1].nx = 1;box[1].ny =box[1].nz=0;
		box[2].nx = 2;box[2].ny =box[2].nz=0;
		box[3].nx = box[3].ny =0; box[3].nz=-1;
		box[4].nx = 1;box[4].ny=0; box[4].nz=-1;
		box[5].nx = 2;box[5].ny=0; box[5].nz=-1;
	}
	freework = (int *)Malloc(sizeof(int)*np,PPTR(box));
	(void ) semi_surveywrite(particles,np,x0,y0,z0,box,nbox,nx,ny,nz,
						r1,r2,mstep,amax,a,boxsize,myrank,nrank,freework,maxd,
						rot);
	Free(freework);
	Free(box);
	return 0;
}
int simplesurvey(pmparticletype *particles,int np,int nx,int ny,int nz,
		int mstep, float amax, float a, float astep,float nextastep,
		float boxsize,
		float omep,float omeplam,float hubble,int myrank,int nrank,int ntype){
	float redshift;
	double r,dr1,dr2;
	int nbox;

	sprintf(surveyfilename,"simple_survey%.2d",ntype);

	a2comovingpixel(&r,&dr1,&dr2,nx,amax,a,astep,nextastep,omep,omeplam,boxsize,hubble);
	r1 = (r-dr1);
	r2 = (r+dr2);
	printf("SURVEY %g %g %g\n",r,dr1,dr2);

	freework = (int *)Malloc(sizeof(int)*np,PPTR(box));
	(void ) simplesurveywrite(particles,np,nx,ny,nz,
						r1,r2,mstep,amax,a,boxsize,myrank,nrank,freework);
	Free(freework);
	return 0;
}
#include <math.h>
#define EPS 1.0e-6
#define JMAX 20

float qsimp(float (*func)(float), float a, float b)
{
	float trapzd(float (*func)(float), float a, float b, int n);
	int j;
	float s,st,ost,os;

	ost = os = -1.0e30;
	for (j=1;j<=JMAX;j++) {
		st=trapzd(func,a,b,j);
		s=(4.0*st-ost)/3.0;
		if (fabs(s-os) < EPS*fabs(os)) return s;
		os=s;
		ost=st;
	}
	return 0.0;
}
#undef EPS
#undef JMAX
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
#define FUNC(x) ((*func)(x))

float trapzd(float (*func)(float), float a, float b, int n)
{
	float x,tnm,sum,del;
	static float s;
	int it,j;

	if (n == 1) {
		return (s=0.5*(b-a)*(FUNC(a)+FUNC(b)));
	} else {
		for (it=1,j=1;j<n-1;j++) it <<= 1;
		tnm=it;
		del=(b-a)/tnm;
		x=a+0.5*del;
		for (sum=0.0,j=1;j<=it;j++,x+=del) sum += FUNC(x);
		s=0.5*(s+(b-a)*sum/tnm);
		return s;
	}
}
#undef FUNC
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
