       subroutine setboundaryparticles(np,particles,nn,nxpos,
     &     nzparticles,zstartpos,
     &     nzprefixel,omep,omeplam,ken,pvmesh,zstart,zwidth,vamp,nspace,
     &     omei,amax)
c      IMPLICIT none
      include 'mpif.h'
#include "fortran.i"
      include "fftw_f77.i"
      real omei,amax
      integer*8 lnp,tlnp
      double precision delx,tdelx,tmpken,tken
       integer np,nn,nxpos,nspace
      integer nx,ny,nz,nzper
       real omep,omeplam,ken,zstart,zwidth,vamp
       real particles(nn,np)
       real pvmesh(2*(nx/2+1),ny,*)
       real vfact,vfact2
       integer lindx,i,j,k
       real zstartpos,pfact,ai,pi
      real displ,mdispl,tmdispl
       integer nzparticles,nzprefixel,ngz
       integer NZBUFFER,rng
      parameter(NZBUFFER=4)
      integer xabp0(-10:NNX+10),xabp1(-10:NNX+10),xabm1(-10:NNX+10)
      integer yabp0(-10:NNY+10),yabp1(-10:NNY+10),yabm1(-10:NNY+10)
      integer zabp0(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabp1(-10:LOCAL_NNZ+NZBUFFER+10)
      integer zabm1(-10:LOCAL_NNZ+NZBUFFER+10)
      common /ptables/ xabp0,xabp1,xabm1,yabp0,yabp1,yabm1,zabp0,
     &       zabp1,zabm1
      real rnx,rny,rnz
      integer local_ny_after_transpose,local_nz,local_z_start,
     &     local_y_start_after_transpose,total_local_size
      common /pmcommon/plan,iplan,nx,ny,nz,local_nz,local_z_start,
     &    local_ny_after_transpose,local_y_start_after_transpose,
     &    total_local_size
      integer myid,nid,ierror
      integer status(MPI_STATUS_SIZE),root
      real ktot,cpu(2),stime,etime
      real const,poten
      integer ii,jj,kk,iim1,jjm1,kkm1,iim2,jjm2,kkm2,iip1,iip2,jjp1,jjp2
      integer kkp1,kkp2
      integer local_mz
      real zfinal

      pi = 3.141592654
      root = 0
      zfinal = zstart+zwidth
      local_mz = int(zfinal) - int(zstart) + 1
      if(zfinal .eq. real(int(zfinal))) local_mz = local_mz - 1



      call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierror)
      call MPI_Comm_size(MPI_COMM_WORLD,nid,ierror)

      ai = 1.
      
      rnx = nx
      rny = ny
      rnz = nz
      rng = rnz
c---  Periodic table for mesh
ccc   local_mz+NZBUFFER is the local periodic condition in the current processor
      nzper = local_mz+NZBUFFER
      do 4 i=-10,0
      xabp0(i)=nx+i
      xabp1(i)=nx+i+1
      yabp0(i)=ny+i
      yabp1(i)=ny+i+1
      zabp0(i)=nzper+i
    4 zabp1(i)=nzper+i+1
      xabp1(0)=1
      yabp1(0)=1
      zabp1(0)=1

      do 5 i=1,nx
      xabp0(i)=i
    5 xabp1(i)=i+1
      xabp1(nx)=1
      do 51 i=1,ny
      yabp0(i)=i
   51 yabp1(i)=i+1
      yabp1(ny)=1

      do 6 i=1,nzper
      zabp0(i) = i
    6 zabp1(i) = i+1
      zabp1(nzper)=1
      do 7 i=nx+1,nx+10
      xabp0(i)=i-nx
    7 xabp1(i)=i+1-nx
      do 71 i=ny+1,ny+10
      yabp0(i)=i-ny
   71 yabp1(i)=i+1-ny

      do 8 i=nzper+1,nzper+10
      zabp0(i)=i-nzper
    8 zabp1(i)=i+1-nzper

c---  For positions we use the pixel size as the length unit
      vfact = (4./3.)*rng/2.*vamp
      vfact2 = -(1./3.)*rng/4.*vamp
c$omp parallel do private(i,j,k,ii,jj,kk,iim1,jjm1,kkm1)
c$omp+ private(iim2,jjm2,kkm2,iip1,jjp1,kkp1,iip2,jjp2,kkp2)
c$omp+ private(iindex)
      do 20 k=1,nzparticles,nzparticles-1
      do 20 j=1,ny/nspace
      do 20 i=1,nx/nspace
	  lindx = i + (nx/nspace)*((j-1)+(ny/nspace)*(k-1))
c--------------------------------------------------------------
      particles(nxpos+1,lindx) = nspace*(i-1.)
      particles(nxpos+2,lindx) = nspace*(j-1.)
      particles(nxpos+3,lindx) = nspace*(k-1.)+zstartpos
c--------------------------------------------------------------
      ii = nspace*(i-1)+1
      jj = nspace*(j-1)+1
      kk = nspace*(k-1)+1+nzprefixel
      iim1 = xabp0(ii-1)
      jjm1 = yabp0(jj-1)
      kkm1 = zabp0(kk-1)
      iim2 = xabp0(iim1-1)
      jjm2 = yabp0(jjm1-1)
      kkm2 = zabp0(kkm1-1)
      iip1 = xabp1(ii)
      jjp1 = yabp1(jj)
      kkp1 = zabp1(kk)
      iip2 = xabp1(iip1)
      jjp2 = yabp1(jjp1)
      kkp2 = zabp1(kkp1)
c--------------------------------------------------------------
      particles(nxpos+4,lindx) = 
     &     vfact*(pvmesh(iip1,jj,kk)-pvmesh(iim1,jj,kk))
     &          +vfact2*(pvmesh(iip2,jj,kk)-pvmesh(iim2,jj,kk))
      particles(nxpos+5,lindx) = 
     &     vfact*(pvmesh(ii,jjp1,kk)-pvmesh(ii,jjm1,kk))
     &          +vfact2*(pvmesh(ii,jjp2,kk)-pvmesh(ii,jjm2,kk))
      particles(nxpos+6,lindx) = 
     &     vfact*(pvmesh(ii,jj,kkp1)-pvmesh(ii,jj,kkm1))
     &          +vfact2*(pvmesh(ii,jj,kkp2)-pvmesh(ii,jj,kkm2))
c--------------------------------------------------------------
   20 continue

c---  For (n,size,seed)=(64,64,17), vx(1,1,1)=-0.0051 & vy(1,1,1)=-0.0049

c***  Push : position at a=ai (dx/da is constant from a=0 to ai)
c---  Displacement from ai*dx/da at particle position
c     pfact = rng*ai*omei**(-0.6)
      pfact = rng*ai/vamp
      delx = 0.D0
      displ = 0
      mdispl = 0.
c--------------------------------------------------------------------
c$omp parallel do private(i,displ)
c$omp+ reduction(+:delx)
c$omp+ reduction(MAX:mdispl)
      do i = 1, np
         particles(nxpos+1,i) = 
     &         amod(particles(nxpos+1,i)+
     &         particles(nxpos+4,i)*pfact+rnx,rnx)
         particles(nxpos+2,i) = 
     &         amod(particles(nxpos+2,i)+
     &         particles(nxpos+5,i)*pfact+rny,rny)
         particles(nxpos+3,i) = 
     &         amod(particles(nxpos+3,i)+
     &         particles(nxpos+6,i)*pfact+rnz,rnz)
         delx = delx + particles(nxpos+4,i)**2 + 
     &         particles(nxpos+5,i)**2+particles(nxpos+6,i)**2
         displ = sqrt(particles(nxpos+4,i)**2+particles(nxpos+5,i)**2+
     &                particles(nxpos+6,i)**2)*pfact
         mdispl = amax1(displ,mdispl)
      enddo
c--------------------------------------------------------------------
      call MPI_REDUCE(delx,tdelx,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      delx = tdelx
      call MPI_BCAST(delx,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &          ierror)
      lnp = np
      call MPI_REDUCE(lnp,tlnp,1,MPI_INTEGER8,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      call MPI_BCAST(tlnp,1,MPI_INTEGER8,0,MPI_COMM_WORLD,ierror)
      if(myid.eq.0)print *, 'P',myid,delx,pfact, tlnp
      if(myid.eq.0)print *,'rms displacement=',dsqrt(delx)*pfact
     &           /sqrt(real(tlnp))
      call MPI_REDUCE(mdispl,tmdispl,1,MPI_REAL,MPI_MAX,0,
     &                MPI_COMM_WORLD,ierror)
      if(myid.eq.0)print *, 'Maximum displacement =',tmdispl


cccc
c     open(1,file='final.out'//char(48+myid))
c     do i = 1, np
c        write(1,*) x(i),y(i),z(i),vx(i),vy(i),vz(i)
c     enddo
c     close(1)
c***  Energy
      tmpken=0.D0
c$omp parallel do reduction(+:tmpken)
      do 70 i=1,np
          tmpken=tmpken+ 
     &        (particles(nxpos+4,i)**2.+particles(nxpos+5,i)**2.
     &        +particles(nxpos+6,i)**2.)
70    continue
      call MPI_REDUCE(tmpken,tken,1,MPI_DOUBLE_PRECISION,MPI_SUM,root,
     &                MPI_COMM_WORLD,ierror)
      tmpken = tken
      call MPI_BCAST(tmpken,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,
     &                ierror)
      if(myid.eq.0)then
      print *,'sum of dx/da**2=',tmpken
      tmpken=0.5D0*8.D0*pi/3.D0*(1.D0/ai+1.D0/omei-1.)*tmpken
C
C possible error?
C
      ktot = 0.
      poten = 0.
      const = ai**3.*tmpken+poten+ktot
      print *,' poten,ken,const=',poten,tmpken,const
      endif
      ken = tmpken
 
    
      if(myid .eq. 0) 
     &     print *,'Generating Initial Condition ',etime(CPU)-stime

	  
      return
      end

