c234567
      subroutine tsctune(den,Nx,Ny,Nz,Nz_local,nstart_z,
     &               particles,nn,nxpos,nend,pmas,myrank,nrank)
      IMPLICIT none    ! This statement is very important
      include 'mpif.h'
      integer Nx,Ny,Nz, nend,nstart_z,Nz_local
	  integer nxpos
	  real start_z
      real pmas,p05
      real den(2*(Nx/2+1),Ny,Nz_local+7)
	  integer nn
	  real particles(nn,nend)
c     real px(*),py(*),pz(*)
      integer xsign,ysign,zsign
      integer myrank,nrank
      integer Nz_per
      integer i,j,k
      integer nearx,neary,nearz,i1,j1,k1,i2,j2,k2,i3,j3,k3
      real xp,yp,zp,xmin,ymin,zmin
      real wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3
	  real wdtmp
	  real wd1,wd2,wd3,wd4,wd5,wd6,wd7,wd8,wd9,wd10
	  real wd11,wd12,wd13,wd14,wd15,wd16,wd17,wd18,wd19,wd20
	  real wd21,wd22,wd23,wd24,wd25,wd26,wd27
      real xd1,yd1,zd1
      integer usndsize,dgetsize,dsndsize,ugetsize
      integer dest,src
      integer status(MPI_STATUS_SIZE),ierror,stag,rtag,tag
      real*4 CPU(2), etime,stime

      
ccc   Nz_per is the z size of local array to pretend periodic boundary conditions
ccc   in the calculation of local density.
      if(myrank.eq.0) stime = etime(CPU)
      Nz_per = Nz_local+7
      do 10 k = 1, Nz_local
      do 10 j = 1, Ny
      do 10 i = 1, Nx
         den(i,j,k) = -1.
10    continue
      do 20 k = Nz_local+1, Nz_local+7, +1
      do 20 j = 1, Ny
      do 20 i = 1, Nx
         den(i,j,k) = 0.
20    continue

      p05 = pmas*0.5
	  start_z = nstart_z
      do i = 1, nend
         xp = particles(nxpos+1,i)
         yp = particles(nxpos+2,i)
         zp = particles(nxpos+3,i)-start_z
         nearx = nint(xp)
         neary = nint(yp)
         nearz = nint(zp)
         xmin = xp-nearx
         ymin = yp-neary
         zmin = zp-nearz
ccc Don`t use isign because this is the internal function of Fortran.
ccc So x,y,zsign were used instead.
         xsign = sign(1.,xmin)
         ysign = sign(1.,ymin)
         zsign = sign(1.,zmin)
         i1 = mod(nearx+Nx,Nx) + 1
         j1 = mod(neary+Ny,Ny) + 1
         k1 = mod(nearz+Nz_per,Nz_per) + 1
         i2 = mod(nearx+Nx+xsign,Nx) + 1
         j2 = mod(neary+Ny+ysign,Ny) + 1
         k2 = mod(nearz+Nz_per+zsign,Nz_per) + 1
         i3 = mod(nearx+Nx-xsign,Nx) + 1
         j3 = mod(neary+Ny-ysign,Ny) + 1
         k3 = mod(nearz+Nz_per-zsign,Nz_per) + 1
         xd1 = abs(xmin)
         yd1 = abs(ymin)
         zd1 = abs(zmin)
         wx1 =(0.75-xd1**2)*pmas
         wy1 = 0.75-yd1**2
         wz1 = 0.75-zd1**2
         wx2 = p05*(0.5+xd1)**2
         wy2 = 0.5*(0.5+yd1)**2
         wz2 = 0.5*(0.5+zd1)**2
         wx3 = p05*(0.5-xd1)**2
         wy3 = 0.5*(0.5-yd1)**2
         wz3 = 0.5*(0.5-zd1)**2
c---  Assign mass to the grid the particle overlaps
         wdtmp = wy1*wz1
         wd1 = wx1*wdtmp
         wd2 = wx2*wdtmp
         wd3 = wx3*wdtmp
         wdtmp = wy2*wz1
         wd4 = wx1*wdtmp
         wd5 = wx2*wdtmp
         wd6 = wx3*wdtmp
         wdtmp = wy3*wz1
         wd7 = wx1*wdtmp
         wd8 = wx2*wdtmp
         wd9 = wx3*wdtmp
         wdtmp = wy1*wz2
         wd10 = wx1*wdtmp
         wd11 = wx2*wdtmp
         wd12 = wx3*wdtmp
         wdtmp = wy2*wz2
         wd13 = wx1*wdtmp
         wd14 = wx2*wdtmp
         wd15 = wx3*wdtmp
         wdtmp = wy3*wz2
         wd16 = wx1*wdtmp
         wd17 = wx2*wdtmp
         wd18 = wx3*wdtmp
         wdtmp = wy1*wz3
         wd19 = wx1*wdtmp
         wd20 = wx2*wdtmp
         wd21 = wx3*wdtmp
         wdtmp = wy2*wz3
         wd22 = wx1*wdtmp
         wd23 = wx2*wdtmp
         wd24 = wx3*wdtmp
         wdtmp = wy3*wz3
         wd25 = wx1*wdtmp
         wd26 = wx2*wdtmp
         wd27 = wx3*wdtmp

         den(i1,j1,k1) = den(i1,j1,k1) + wd1
         den(i2,j1,k1) = den(i2,j1,k1) + wd2
         den(i3,j1,k1) = den(i3,j1,k1) + wd3
         den(i1,j2,k1) = den(i1,j2,k1) + wd4
         den(i2,j2,k1) = den(i2,j2,k1) + wd5
         den(i3,j2,k1) = den(i3,j2,k1) + wd6
         den(i1,j3,k1) = den(i1,j3,k1) + wd7
         den(i2,j3,k1) = den(i2,j3,k1) + wd8
         den(i3,j3,k1) = den(i3,j3,k1) + wd9
         den(i1,j1,k2) = den(i1,j1,k2) + wd10
         den(i2,j1,k2) = den(i2,j1,k2) + wd11
         den(i3,j1,k2) = den(i3,j1,k2) + wd12
         den(i1,j2,k2) = den(i1,j2,k2) + wd13
         den(i2,j2,k2) = den(i2,j2,k2) + wd14
         den(i3,j2,k2) = den(i3,j2,k2) + wd15
         den(i1,j3,k2) = den(i1,j3,k2) + wd16
         den(i2,j3,k2) = den(i2,j3,k2) + wd17
         den(i3,j3,k2) = den(i3,j3,k2) + wd18
         den(i1,j1,k3) = den(i1,j1,k3) + wd19
         den(i2,j1,k3) = den(i2,j1,k3) + wd20
         den(i3,j1,k3) = den(i3,j1,k3) + wd21
         den(i1,j2,k3) = den(i1,j2,k3) + wd22
         den(i2,j2,k3) = den(i2,j2,k3) + wd23
         den(i3,j2,k3) = den(i3,j2,k3) + wd24
         den(i1,j3,k3) = den(i1,j3,k3) + wd25
         den(i2,j3,k3) = den(i2,j3,k3) + wd26
         den(i3,j3,k3) = den(i3,j3,k3) + wd27

c        den(i1,j1,k1) = den(i1,j1,k1) + wx1*wy1*wz1
c        den(i2,j1,k1) = den(i2,j1,k1) + wx2*wy1*wz1
c        den(i3,j1,k1) = den(i3,j1,k1) + wx3*wy1*wz1
c        den(i1,j2,k1) = den(i1,j2,k1) + wx1*wy2*wz1
c        den(i2,j2,k1) = den(i2,j2,k1) + wx2*wy2*wz1
c        den(i3,j2,k1) = den(i3,j2,k1) + wx3*wy2*wz1
c        den(i1,j3,k1) = den(i1,j3,k1) + wx1*wy3*wz1
c        den(i2,j3,k1) = den(i2,j3,k1) + wx2*wy3*wz1
c        den(i3,j3,k1) = den(i3,j3,k1) + wx3*wy3*wz1
c        den(i1,j1,k2) = den(i1,j1,k2) + wx1*wy1*wz2
c        den(i2,j1,k2) = den(i2,j1,k2) + wx2*wy1*wz2
c        den(i3,j1,k2) = den(i3,j1,k2) + wx3*wy1*wz2
c        den(i1,j2,k2) = den(i1,j2,k2) + wx1*wy2*wz2
c        den(i2,j2,k2) = den(i2,j2,k2) + wx2*wy2*wz2
c        den(i3,j2,k2) = den(i3,j2,k2) + wx3*wy2*wz2
c        den(i1,j3,k2) = den(i1,j3,k2) + wx1*wy3*wz2
c        den(i2,j3,k2) = den(i2,j3,k2) + wx2*wy3*wz2
c        den(i3,j3,k2) = den(i3,j3,k2) + wx3*wy3*wz2
c        den(i1,j1,k3) = den(i1,j1,k3) + wx1*wy1*wz3
c        den(i2,j1,k3) = den(i2,j1,k3) + wx2*wy1*wz3
c        den(i3,j1,k3) = den(i3,j1,k3) + wx3*wy1*wz3
c        den(i1,j2,k3) = den(i1,j2,k3) + wx1*wy2*wz3
c        den(i2,j2,k3) = den(i2,j2,k3) + wx2*wy2*wz3
c        den(i3,j2,k3) = den(i3,j2,k3) + wx3*wy2*wz3
c        den(i1,j3,k3) = den(i1,j3,k3) + wx1*wy3*wz3
c        den(i2,j3,k3) = den(i2,j3,k3) + wx2*wy3*wz3
c        den(i3,j3,k3) = den(i3,j3,k3) + wx3*wy3*wz3
      enddo
ccccc These lines send upper swap den(den(*,*,Nz_local+1~2)) to a upper node.
ccccc Be careful! The small size of buffer resources makes the sending
ccccc process with one column! Not one slice!!!!! 
ccccc dest : send array to dest`th node
ccccc src : receivce array from src`th node
      usndsize = 2*(Nx/2+1)*Ny*2
      dgetsize = usndsize
      dest = mod(myrank+1+nrank,nrank)
      src = mod(myrank-1+nrank,nrank)
      stag = 0
      rtag = 0
c     if(myrank .EQ. 0) stime = etime(CPU)
      call MPI_SENDRECV_REPLACE(den(1,1,Nz_local+1),usndsize,
     &   MPI_REAL,dest,stag,src,rtag,MPI_COMM_WORLD,status,ierror)
c     if(myrank .EQ. 0) print *,'Sending and Receiving time(upper) :',
c    &              etime(CPU)-stime
      do 30 k = 1, 2
      do 30 j = 1, Ny
      do 30 i = 1, Nx
         den(i,j,k) = den(i,j,k) + den(i,j,Nz_local+k)
30    continue
ccccc These lines send lower swap(den(*,*,Nz_local+7)) to a lower slice.
ccccc dest : send array to dest'th node
ccccc src : receivce array from src'th node
      dsndsize = 2*(Nx/2+1)*Ny
      ugetsize = dsndsize
      dest = mod(myrank-1+nrank,nrank)
      src = mod(myrank+1+nrank,nrank)
      stag = 0
      rtag = 0
c     if(myrank .EQ. 0) stime = etime(CPU)
      call MPI_SENDRECV_REPLACE(den(1,1,Nz_local+7),dsndsize,
     &       MPI_REAL,dest,stag,src,rtag,MPI_COMM_WORLD,status,ierror)
c     if(myrank .EQ. 0) print *,'Sending and Receiving time(lower) :',
c    &              etime(CPU)-stime
      do 40 j = 1, Ny
      do 40 i = 1, Nx
         den(i,j,Nz_local) = den(i,j,Nz_local) + 
     &                               den(i,j,Nz_local+7)
40    continue
      if(myrank.eq.0) print *,' CPU(TSC) ', etime(CPU)-stime
      return
      end
